/******************************************************************************
* Copyright (c) 2003 Tom Cashmore
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to
* deal in the Software without restriction, including without limitation the
* rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
* sell copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.

* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
* IN THE SOFTWARE.
*
*       Applisation : MIDAS
*       Filename : Commoninclude.h
* 		Shared common includes for all Common/ code segments.
*
*       Updated :
*               11/10/2003 - Added function and header comments.
*		11/20/2003 - Started porting Common functions over to windows
******************************************************************************/

// Prety little work arounds for the Windows platform (Bastards!)
#ifdef __WIN32__
//	Use Sleep for sleep() function
#define sleep(x) Sleep(x * 1000)

//	Redefine Non Blocked fnctl with ioctlsocket.
#define fcntl(x, y, O_NONBLOCK) unsigned long val = 1; ioctlsocket(x, FIONBIO, &val)

//	Refefines for the u_ vars
#define u_char unsigned char

//	b* redefines (Need to just swap this out of the source)
#define bcmp(s1, s2, n)	memcmp ((s1), (s2), (n))
#define bcopy(s, d, n)	memcpy ((d), (s), (n))
#define bzero(s, n)	memset ((s), 0, (n))

//	Windows Services dont like popen command, so we use are internal (kludge) popen functions.
#define popen(x, y) Service_popen(x)
#define pclose(x)   Service_pclose(x)
FILE * Service_popen(char *);
int Service_pclose(FILE *);

#endif

#include "DString/DString.h"
#include "Socket/Socket.h"
#include "XMLparser/XMLparser.h"
#include "Util/util.h"

// Windows doesnt not support forking (Bastards!)
#ifndef __WIN32__
#include "Forker/forker.h"
#endif

// Do we have MySQL Support?
#ifdef HAVEMYSQL
#include "MySQL-Abstract/mysqldb.h"
#include "rrd/rrd.h"
#endif

#include "md5/md5.h"
#include "SNMP/snmp.h"
#include "Base64/Base64.h"
#include "Crypt/Crypt.h"
#include "ping/ping.h"
#include "Client/client.h"

#ifdef DMALLOC
#include "/usr/src/dmalloc-4.8.2/dmalloc.h"
#endif

#ifdef NEEDATOLL
#include "atoll/atoll.h"
#endif

#ifdef NEEDSTRSEP
#include "strsep/strsep.h"
#endif

#ifdef NEEDGETTIMEOFDAY
#include "gettimeofday/gettimeofday.h"
#endif

#ifdef NEEDCLIENT
#include "client/client.h"
#endif

#ifdef NODEBUG
#define MyDebug(...);
#endif 
