/******************************************************************************
* Copyright (c) 2003 Tom Cashmore
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to
* deal in the Software without restriction, including without limitation the
* rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
* sell copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.

* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
* IN THE SOFTWARE.
*
*       Applisation : MIDAS
*       Filename : mysqldb.h
* 		Function defines for mysqldb.c
*
*       Updated :
*               11/10/2003 - Added function and header comments.
*
******************************************************************************/
#include <mysql/mysql.h>

struct DBR
{
        unsigned num;
        MYSQL_RES *results;
};

struct SQLCFG
{
        char * IP;
        char * user;
        char * passwd;
        char * db;
	char * unixsocket;
        int port;
};

struct DBR * dbFree(struct DBR *);
struct DBR * dbQuery(char * query, struct SQLCFG *);
MYSQL_ROW dbResult(struct DBR * dbr);

struct DBR * dbQuery_P(MYSQL * mysql, char * query);
MYSQL * dbConnect(MYSQL * mysql, struct SQLCFG * sqlcfg);
void dbClose(MYSQL * mysql);
