/******************************************************************************
* Copyright (c) 2003 Tom Cashmore
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to
* deal in the Software without restriction, including without limitation the
* rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
* sell copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.

* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
* IN THE SOFTWARE.
*
*       Applisation : MIDAS
*       Filename : XMLparser.h
* 		Function defines for XMLparser.c
*
*       Updated :
*               11/11/2003 - Added function and header comments.
*
******************************************************************************/
struct XMLLeaf {
	long 	ID;
	char	*Tag;
	char 	*Value;
	char	*Fullname;
	struct  XMLLeaf * ParentLeaf;
	long	ParentID;
	struct	XMLLeaf	* PrevLeaf;
	struct	XMLLeaf	* NextLeaf;
};

//
// XML Functions
struct XMLLeaf * StringToXMLTree(char * instr);
char * XMLTreeToString(struct XMLLeaf * RootLeaf);
struct XMLLeaf * AddXMLLeaf(struct XMLLeaf * ParentLeaf, struct XMLLeaf *PrevLeaf, char *Tag, char *Value, long TagCount);
struct XMLLeaf * FindXMLLeafByTag(struct XMLLeaf * RootLeaf, char * Tag);
struct XMLLeaf * FindXMLLeafByID(struct XMLLeaf * RootLeaf, long ID);
long ReturnXMLLeafParentID(struct XMLLeaf * RootLeaf, char * Tag);
long ReturnXMLLeafID(struct XMLLeaf * RootLeaf, char * Tag);
struct XMLLeaf * FindXMLLeafByParent(struct XMLLeaf * RootLeaf, struct XMLLeaf * ParentLeaf);
struct XMLLeaf * FindXMLLeafByParentID(struct XMLLeaf * RootLeaf, long ParentID);
char * ReturnXMLLeafValue(struct XMLLeaf * RootLeaf, char * Tag);
void DelXMLLeaf(struct XMLLeaf * Leaf);
struct XMLLeaf * DelXMLLeafTree(struct XMLLeaf *Leaf);
struct XMLLeaf * DelSubXMLTree(struct XMLLeaf * RootLeaf);

struct XMLLeaf * BuildSubXMLTree(struct XMLLeaf * RootLeaf, long ID, int IsRoot);
char * CleanXMLValueString(char * Value);
char * UnCleanXMLValueString(char * Value);
void DebugXMLTree(char * LocString, struct XMLLeaf * XMLTree, int);
unsigned CountXMLLeafByTag(struct XMLLeaf * CheckLeaf, char * Tag);
struct XMLLeaf * FileToXMLTree(char * file);
