/******************************************************************************
* Copyright (c) 2003 Tom Cashmore
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to
* deal in the Software without restriction, including without limitation the
* rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
* sell copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.

* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
* IN THE SOFTWARE.
*
*       Applisation : MIDAS
*       Filename : rrd.h
*		Function defines for rrd.c
*
*       Updated :
*               11/11/2003 - Added function and header comments.
*
******************************************************************************/
struct RRDCreateDS {
	char * Title;
	char * Format;
	unsigned Sequences;
	unsigned Interval;
	struct RRDCreateArch * Archive;
};

struct RRDCreateArch {
	unsigned Sequences;
	unsigned Interval;
	struct RRDCreateArch * NextArch;
};

int RRD_UpdateDSValue(int DSID, unsigned TimeStamp, float Value, MYSQL * mysql);
void RRD_ShiftValues(int DSID, unsigned TimeStamp, unsigned Interval, unsigned Sequences, char *, char *, MYSQL * mysql);
float RRD_AverageValue(int ID, char * TableName, char * FieldName, unsigned StartTimeStamp, unsigned Interval, MYSQL * mysql);
float RRD_DerivedValue(int DSID, unsigned Sequences, char *, char *, MYSQL * mysql);
unsigned RRD_MaxID(char * TableName, char * FieldName, MYSQL * mysql);
int RRD_CreateDataSource(struct RRDCreateDS * RRDDef, MYSQL * mysql);
void RRD_UpdateArchValues(int DSID, unsigned TimeStamp, float Value, MYSQL * mysql);
