<?
/********************************************************************
Copyright (c) 2003 Jason Sessler

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
********************************************************************/

/********************************************************************
	Changelog:
	01/31/2004  -   Added support for determining HTTP/HTTPS sessions
	                BUG: #888300

********************************************************************/

include "inc/common.php";
include _ABS_ROOT . "/lib/mysql.inc.php";
include _ABS_ROOT . "/lib/authentication.inc.php";
include _ABS_ROOT . "/lib/html.inc.php";
include _ABS_ROOT . "/themes/plain_blue.php";

$invalid = FALSE;

$auth = $session->CheckAuthentication($_COOKIE['_SESSKEY']);
if(isset($_POST['authname'])) {
    $auth = $session->Authenticate($_POST['authname'], $_POST['authpass']);
    if(!$auth["return"])
        $invalid = TRUE;
}

if($auth["return"]) {
    header("Location: " . $PROTOCOL . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']) . "/webview_main.php");
    exit;
}

printf("<HTML>\n");
printf("<HEAD>\n");
printf("<META HTTP-EQUIV='CACHE-CONTROL' CONTENT='NO-CACHE'>\n");
printf("<META HTTP-EQUIV='PRAGMAS' CONTENT='NO-CACHE'>\n");
printf("<TITLE>%s: Authentication Required</TITLE>\n", _APPNAME);
printf("</HEAD>\n");
printf("<LINK rel=stylesheet href=%s type=text/css>\n", $color['css']);

printf("<BODY bgcolor=%s onload='javascript:document.authentication.authname.focus();' topmargin=10 leftmargin=10>\n", $color[3]);

if($invalid) {
    printf("<FORM name=authentication method=post action=index.php>\n");
    echo html_tag("TABLE",
            html_tag("TR",
                html_tag("TD",
                    html_tag("TABLE",
                        html_tag("TR",
                            html_tag("TD", sprintf("<font color=" . $color[2] . "><b>%s</b></font>\n", $auth["msg"]), $color[0], "colspan=3 align=center"),
						"", "") .
                        html_tag("TR",
                            html_tag("TD", "<b>USERNAME</b>\n", $color[4], "") .
                            html_tag("TD", "<input type=textbox size=20 name=authname>\n",
                                $color[4], ""),
                        "", "") .
                        html_tag("TR",
                            html_tag("TD", "<b>PASSWORD</b>\n", $color[4], "") .
                            html_tag("TD", "<input type=password size=20 name=authpass>\n",
                                $color[4], ""),
                        "", "") .
                        html_tag("TR",
                            html_tag("TD", _APPNAME . " " . _VERSION ."\n",
                                $color[12], "colspan=2 height=50% align=center valign=center"),
                        "", "") .
                        html_tag("TR",
                            html_tag("TD",
                                "<input type=submit value=Login> <input type=reset>\n",
                                $color[0], "colspan=3 align=center"),
                        "", ""),
                    $color[10], ""),
                $color[12], "width=100% height=100% align=center valign=center"),
            "", ""),
        $color[10], "width=100% height=100% align=center valign=center");
} else {
    printf("<FORM name=authentication method=post action=index.php>\n");
    echo html_tag("TABLE",
            html_tag("TR",
                html_tag("TD",
                    html_tag("TABLE",
                        html_tag("TR",
                            html_tag("TD", "<b>Authentication Required</b>\n", $color[0], "class=blacksmall colspan=3 align=center"),
						"", "") .
                        html_tag("TR",
                            html_tag("TD", "<b>USERNAME</b>\n", $color[4], "") .
                            html_tag("TD", "<input type=textbox size=20 name=authname>\n",
                                $color[4], ""),
                            "", "") .
                        html_tag("TR",
                            html_tag("TD", "<b>PASSWORD</b>\n", $color[4], "") .
                            html_tag("TD", "<input type=password size=20 name=authpass>\n",
                                $color[4], ""),
                            "", "") .
                        html_tag("TR",
                            html_tag("TD", _APPNAME . " " . _VERSION ."\n",
                                $color[12], "colspan=2 height=50% align=center valign=center"),
                        "", "") .
                        html_tag("TR",
                            html_tag("TD",
                                "<input type=submit value=Login> <input type=reset>\n",
                                $color[0], "colspan=3 align=center"),
                        "", ""),
                    $color[10], ""),
                $color[12], "width=100% height=100% align=center valign=center"),
            "", ""),
        $color[10], "width=100% height=100% align=center valign=center");
}

printf("</FORM>\n");

printf("</BODY>\n");
printf("</HTML>\n");
?>
