<?
/********************************************************************
Copyright (c) 2003 Jason Sessler

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
********************************************************************/

/********************************************************************
	Changelog:
	01/24/2004  -   Sorting Graph Items by ID3

	12/31/2003  -   Removed build_url() links using $_SERVER['PHP_SELF']
	                Changed this to use _DOC_ROOT . "<filename>"

********************************************************************/

require _ABS_ROOT . "/modules/graphstats/graphing.inc.php";

function load_graph_stats()
{
	if(@function_exists("addModuleAction")) {
		addModuleAction(_VIEWHOST_MODULES, "Graph Stats", "graph_stats");
	}
	return TRUE;
}

function graph_stats()
{
	global $db, $args, $_SERVER, $session;

	if($session->checkAccessLevel(_GROUP_WRITE)) {
		if($db->dbc) {
			$gph = new conn_mySQL();
			$gph->db_use_conn($db->dbc, $db->db);
			$closeit = FALSE;
		} else {
			global $credentials;
			$gph = new conn_mySQL($credentials);
			$gph->db_new_conn();
			$closeit = TRUE;
		}

		if($args['resetStat']) {
			$info['Type'] = $args['Type'];
			$info['ID1'] = $args['ID1'];
			$info['ID2'] = $args['ID2'];
			if(!delete_graph_stats($info))
			    $links[] = "<SPAN class='errmsg'>Error deleting Stats.</SPAN> <br>\n";
		}

		$gph->add_table(_TABLE_RRD_MIDAS_ID);
		$gph->add_select_item(Array("DSID", "Type"));

		if($args['HID']) {
			$ID1 = $args['HID'];
		    $where[] = sprintf("ID1='%s'", $ID1);
		}
		if($args['CID'] && $args['CID']) {
			$ID2 = sprintf("%s_%s",  $args['CID'], $args['TID']);
		    $where[] = sprintf("ID2='%s'", $ID2);
		}

		$gph->clause = sprintf("where %s", implode(" AND ", $where));
	    $gph->add_extra("GROUP BY Type");

	    $ret = $gph->compile_query("SELECT");
		if($ret['return']) {
			$gph->run_query();
			$label = Array("CHECK"  => ($ID2) ? "Check " : "Host Checks",
			               "SNORT"  => "IDS",
			               "NETMON" => "Network Monitor");
			if($gph->rows) {
				for($x=0;$x<$gph->rows;$x++) {
					$gph->step();
					$links[] = sprintf("<nobr>&nbsp;&nbsp;<A HREF='%s' onClick=\"reset = confirm('Do you wish to reset these stats?'); if(reset) {return true}; else {return false;}\">%s Stats</A></nobr> <br>\n", buildURL(_DOC_ROOT . "/view_host.php", array_merge($args, Array("resetStat" => 1, "Type" => $gph->res['Type'], "ID1" => $ID1, "ID2" => $ID2))), $label[$gph->res['Type']]);
				}
			} else {
				$links[] = "&nbsp;&nbsp;<b>No Stats Detected</b>\n";
			}
		} else {
			$links[] = "&nbsp;&nbsp;<b>Error</b>";
		}

		$gph->clear_res();

		if($closeit)
		    $gph->db_close();

		$gph = null;
	} else {
		$links[] = "&nbsp;&nbsp;<b>None</b>";
	}

	return Array('link' => sprintf("<b>Reset:<b><br> %s", implode(" ", $links)));
}

function delete_graph_stats($args)
{
	global $db, $session;

	if($session->checkAccessLevel(_GROUP_WRITE)) {
		if($db->dbc) {
			$gph = new conn_mySQL();
			$gph->db_use_conn($db->dbc, $db->db);
			$closeit = FALSE;
		} else {
			global $credentials;
			$gph = new conn_mySQL($credentials);
			$gph->db_new_conn();
			$closeit = TRUE;
		}

		$gph->add_table(_TABLE_RRD_MIDAS_ID);
		$gph->add_select_item(Array(_TABLE_RRD_MIDAS_ID => "DSID", _TABLE_RRD_ARCHIVESOURCE => "DAID"));

		if($args['Type'])
			$where[] = sprintf("Type='%s'", $args['Type']);
		if($args['ID1'])
			$where[] = sprintf("ID1='%s'", $args['ID1']);
		if($args['ID2'])
			$where[] = sprintf("ID2='%s'", $args['ID2']);

		$gph->clause .= sprintf("LEFT JOIN %s on (%s.DSID=%s.DSID) ", _TABLE_RRD_ARCHIVESOURCE, _TABLE_RRD_MIDAS_ID, _TABLE_RRD_ARCHIVESOURCE);
		$gph->clause .= sprintf("where %s", implode(" AND ", $where));
		$ret = $gph->compile_query("SELECT");
		if($ret['return']) {
			$gph->run_query();
			for($x=0;$x<$gph->rows;$x++) {
				$gph->step();
				if(!in_multi_array(sprintf("DSID='%s'", $gph->res['DSID']), $DSID)) {
					$DSID[] = sprintf("DSID='%s'", $gph->res['DSID']);
				}
				$DAID[] = sprintf("DAID='%s'", $gph->res['DAID']);
			}
			$gph->clear_res();

			$TABLES['DSID'][] = _TABLE_RRD_MIDAS_ID;
			$TABLES['DSID'][] = _TABLE_RRD_DATASOURCE;
			$TABLES['DSID'][] = _TABLE_RRD_DATAVALUES;
			$TABLES['DAID'][] = _TABLE_RRD_ARCHIVESOURCE;
			$TABLES['DAID'][] = _TABLE_RRD_ARCHIVEVALUES;

			foreach($TABLES as $type => $value) {
				if(is_array($$type)) {
					foreach($value as $subvalue) {
						$gph->add_table($subvalue);
						$gph->clause = sprintf("where %s", implode(" OR ", $$type));
						$ret = $gph->compile_query("DELETE");
						if($ret['return']) {
							$gph->run_query();
						}
						$gph->clear_res();
					}
				}
			}
		} else {
			return FALSE;
		}
		if($closeit)
		    $gph->db_close();
	}
	
	return TRUE;
}

function graphing($arguments, $graph = "day")
{
	global $db, $color, $args;

	$HOUR = 3600;
	$DAY  = 86400;
	$WEEK = 604800;

	if($db->dbc) {
		$gph = new conn_mySQL();
		$gph->db_use_conn($db->dbc, $db->db);
		$closeit = FALSE;
	} else {
		global $credentials;
		$gph = new conn_mySQL($credentials);
		$gph->db_new_conn();
		$closeit = TRUE;
	}

	if(!$graph)
		$graph = "day";

	$TYPE = $arguments['type'];
	$ID1  = $arguments['HID'];

	switch($TYPE) {
		case "CHECK":
		    $rrd_graph = sprintf("%s/%s-CHECK-%s_%s-%s.png",
				_RRD_ROOT, $arguments['HID'], $arguments['CID'], $arguments['TID'], $graph);
			$webTitle = "<b>Host Check Statistics</b>";

			$ID2 = sprintf("%s_%s", $arguments['CID'], $arguments['TID']);
			break;
		case "SNORT":
			$rrd_graph = sprintf("%s/%s-SNORT-STAT-%s.png", _RRD_ROOT, $arguments['HID'], $graph);
			$webTitle = "<b>IDS Statistics</b>";

			$ID2 = "STAT";
			break;
		case "NETMON":
		    $rrd_graph = sprintf("%s/%s-NETMON-%s-%s.png", _RRD_ROOT, $arguments['HID'], $arguments['ITEM'], $graph);
			if(strpos($arguments['ITEM'], "_") !== FALSE) {
			    $info = explode("_", $arguments['ITEM']);
			    $webTitle = sprintf("<b>NetMon Statistics: Protocol [%s] Port [%s] Type [%s]</b>", $info[2], $info[3], $info[1]);
			} else {
				$webTitle = sprintf("<b>NetMon Statistics: Type [%s]</b>", $arguments['ITEM']);
			}

			$ID2 = $arguments['ITEM'];
			break;
		default:
		    $rrd_graph = FALSE;
	}

	if($rrd_graph) {
		$imageAge = time() - @filemtime(_ABS_ROOT . $rrd_graph);
		if($imageAge > 300) {
			@unlink(_ABS_ROOT . $rrd_graph);
			$img = new graph(NULL,NULL,NULL,_ABS_ROOT . $rrd_graph);

			$gph->add_table(_TABLE_RRD_MIDAS_ID);
			$gph->add_select_item(Array(_TABLE_RRD_MIDAS_ID => "ID3", _TABLE_RRD_DATASOURCE => "Title"));
			$gph->clause  = sprintf("LEFT JOIN %s on (%s.DSID=%s.DSID) ", _TABLE_RRD_DATASOURCE, _TABLE_RRD_MIDAS_ID, _TABLE_RRD_DATASOURCE);
			$gph->clause .= sprintf("where %s.Type='$TYPE' AND %s.ID1='$ID1' AND %s.ID2='$ID2'",
							_TABLE_RRD_MIDAS_ID, _TABLE_RRD_MIDAS_ID, _TABLE_RRD_MIDAS_ID);
            $ret = $gph->compile_query("SELECT");
            if($ret['return']) {
				$gph->run_query();
				if($gph->rows > 0) {
					for($x=0;$x<$gph->rows;$x++) {
						$gph->step();
						$title[$gph->res['ID3']] = $gph->res['Title'];
					}
					@ksort($title, SORT_NUMERIC);
				} else {
					return FALSE;
				}
			} else {
				return FALSE;
			}

			switch($graph) {
				case "day":
					$baseTime = mktime(date("H")+1,0,0);

				    $gph->add_select_item(Array(_TABLE_RRD_DATAVALUES => Array("TimeStamp", "Value")));
				    $gph->add_extra("ORDER by TimeStamp ASC");
				    for($x=0;$x<24;$x++) {
				    	$offset = $baseTime - ($x*$HOUR);
						$gph->clause  = sprintf("LEFT JOIN %s on (%s.DSID=%s.DSID) ", _TABLE_RRD_DATASOURCE, _TABLE_RRD_MIDAS_ID, _TABLE_RRD_DATASOURCE);
						$gph->clause .= sprintf("LEFT JOIN %s on (%s.DSID=%s.DSID) ", _TABLE_RRD_DATAVALUES, _TABLE_RRD_MIDAS_ID, _TABLE_RRD_DATAVALUES);
						$gph->clause .= sprintf("where %s.Type='$TYPE' AND %s.ID1='$ID1' AND %s.ID2='$ID2' AND (%s.TimeStamp>=%s AND %s.TimeStamp<%s)",
										_TABLE_RRD_MIDAS_ID, _TABLE_RRD_MIDAS_ID, _TABLE_RRD_MIDAS_ID, _TABLE_RRD_DATAVALUES, $offset-$HOUR, _TABLE_RRD_DATAVALUES, $offset);
						$ret = $gph->compile_query("SELECT");
						$data = Array();
						if($ret['return']) {
							$gph->run_query();
							for($y=0;$y<$gph->rows;$y++) {
								$gph->step();
								$data[$gph->res['ID3']][round(($offset-$gph->res['TimeStamp'])/300)] = $gph->res['Value'];
							}
							@reset($title);
							while(!is_null($key = @key($title))) {
								for($z=0;$z<12;$z++) {
									if(!isset($data[$key][$z+1])) {
										$results[$z] = NULL;
									} else {
										$results[$z] = $data[$key][$z+1];
									}
								}

								$img->add_graph_data(date("H:00", $offset),$title[$key], $results);
								@next($title);
							}
						}
					}
					break;
				case "week":
				    $Sunday   = 1 + (7 - date("w", mktime(23,59,59,1,1,date("Y"))));
				    $baseTime = mktime(23,59,59,1,$Sunday,date("Y")) + ((date("W")-1)*$WEEK);
				    //printf("%s <br>\n", date("r", $baseTime));
				    $gph->add_select_item(Array(_TABLE_RRD_ARCHIVEVALUES => Array("TimeStamp", "Value")));
				    $gph->add_extra("ORDER by TimeStamp ASC");
				    for($x=0;$x<4;$x++) {
				    	$offset = $baseTime - ($x*$WEEK);
				    	//printf("Week: %s <br>\n", date("W"));
				    	//printf("Offset: %s <br>\n", date("r", $offset));
				    	//printf("xTime: X: %s WEEK: %s | %s <br>\n", $x, $WEEK, ($x*$WEEK));
				    	//printf("%s <br>\n", date("r", $offset));
				    	$gph->clause  = sprintf("LEFT JOIN %s on (%s.DSID=%s.DSID) ", _TABLE_RRD_DATASOURCE, _TABLE_RRD_MIDAS_ID, _TABLE_RRD_DATASOURCE);
						$gph->clause .= sprintf("LEFT JOIN %s on (%s.DSID=%s.DSID) ", _TABLE_RRD_ARCHIVESOURCE, _TABLE_RRD_MIDAS_ID, _TABLE_RRD_ARCHIVESOURCE);
						$gph->clause .= sprintf("LEFT JOIN %s on (%s.DAID=%s.DAID) ", _TABLE_RRD_ARCHIVEVALUES, _TABLE_RRD_ARCHIVESOURCE, _TABLE_RRD_ARCHIVEVALUES);
						$gph->clause .= sprintf("where %s.Type='$TYPE' AND %s.ID1='$ID1' AND %s.ID2='$ID2' AND (%s.TimeStamp>=%s AND %s.TimeStamp<%s) AND %s.Intervals=21600",
										_TABLE_RRD_MIDAS_ID, _TABLE_RRD_MIDAS_ID, _TABLE_RRD_MIDAS_ID, _TABLE_RRD_ARCHIVEVALUES, $offset-$WEEK, _TABLE_RRD_ARCHIVEVALUES, $offset, _TABLE_RRD_ARCHIVESOURCE);
						$ret = $gph->compile_query("SELECT");
						$data = Array();
						if($ret['return']) {
							$gph->run_query();
							for($y=0;$y<$gph->rows;$y++) {
								$gph->step();
								$data[$gph->res['ID3']][round(($offset-$gph->res['TimeStamp'])/21600)] = $gph->res['Value'];
							}
							@reset($title);
							while(!is_null($key = @key($title))) {
								for($z=0;$z<28;$z++) {
									if(!isset($data[$key][$z+1])) {
										$results[$z] = NULL;
									} else {
										$results[$z] = $data[$key][$z+1];
									}
								}

								$img->add_graph_data(date("\W\e\e\k W", $offset),$title[$key], $results);
								@next($title);
							}
						}
					}
				    break;
				case "year":
				    $baseTime = mktime(23,59,59,date("m")+1,0);
				    $gph->add_select_item(Array(_TABLE_RRD_ARCHIVEVALUES => Array("TimeStamp", "Value")));
				    $gph->add_extra("ORDER by TimeStamp ASC");
				    $offset = $baseTime;
				    for($x=0;$x<12;$x++) {
				    	$offset -= $secsInMonth;
				    	$secsInMonth = $offset - mktime(23,59,59,date("m")-$x,0);
				    	$daysInMonth = round($secsInMonth/$DAY);
				    	$gph->clause  = sprintf("LEFT JOIN %s on (%s.DSID=%s.DSID) ", _TABLE_RRD_DATASOURCE, _TABLE_RRD_MIDAS_ID, _TABLE_RRD_DATASOURCE);
						$gph->clause .= sprintf("LEFT JOIN %s on (%s.DSID=%s.DSID) ", _TABLE_RRD_ARCHIVESOURCE, _TABLE_RRD_MIDAS_ID, _TABLE_RRD_ARCHIVESOURCE);
						$gph->clause .= sprintf("LEFT JOIN %s on (%s.DAID=%s.DAID) ", _TABLE_RRD_ARCHIVEVALUES, _TABLE_RRD_ARCHIVESOURCE, _TABLE_RRD_ARCHIVEVALUES);
						$gph->clause .= sprintf("where %s.Type='$TYPE' AND %s.ID1='$ID1' AND %s.ID2='$ID2' AND (%s.TimeStamp>=%s AND %s.TimeStamp<%s) AND %s.Intervals=86400",
										_TABLE_RRD_MIDAS_ID, _TABLE_RRD_MIDAS_ID, _TABLE_RRD_MIDAS_ID, _TABLE_RRD_ARCHIVEVALUES, $offset-$secsInMonth, _TABLE_RRD_ARCHIVEVALUES, $offset, _TABLE_RRD_ARCHIVESOURCE);
						$ret = $gph->compile_query("SELECT");
						$data = Array();
						if($ret['return']) {
							$gph->run_query();
							for($y=0;$y<$gph->rows;$y++) {
								$gph->step();
								$data[$gph->res['ID3']][round(($offset-$gph->res['TimeStamp'])/$DAY)] = $gph->res['Value'];
							}
							@reset($title);
							while(!is_null($key = @key($title))) {
								for($z=0;$z<$daysInMonth;$z++) {
									if(!isset($data[$key][$z+1])) {
										$results[$z] = NULL;
									} else {
										$results[$z] = $data[$key][$z+1];
									}
								}

								$img->add_graph_data(date("M", $offset+1),$title[$key], $results);
								@next($title);
							}
						}
					}
				    break;
				default:
					if($closeit)
			    		$gph->db_close();
					$gph = NULL;
				    return FALSE;
			}
			$gph->clear_res();

			if($closeit)
			    $gph->db_close();
			$gph = NULL;
//print_r($img->data);
//print_r($data);
			$img->build_line_graph();
		}

		clearstatcache();
		
		$graph = html_tag("TR",
			         html_tag("TD",
			             html_tag("TABLE",
			                 html_tag("TR",
			                     html_tag("TD", $webTitle, $color[0], "colspan=2 class=blacksmall align=center"),
			                 "", "") .
			                 html_tag("TR",
			                     html_tag("TD",
			                         sprintf("<nobr>&nbsp;<A HREF='%s'>[Last 24 Hours]</A></nobr><br>\n", buildURL($_SERVER['PHP_SELF'], array_merge($args, Array($arguments['graphType'] => "day")))) .
			                         sprintf("<nobr>&nbsp;<A HREF='%s'>[Last 4 Weeks]</A></nobr><br>\n", buildURL($_SERVER['PHP_SELF'], array_merge($args, Array($arguments['graphType'] => "week")))) .
			                         sprintf("<nobr>&nbsp;<A HREF='%s'>[Last Year]</A></nobr>\n", buildURL($_SERVER['PHP_SELF'], array_merge($args, Array($arguments['graphType'] => "year")))),
							     $color[3], "width=20% align=left") .
								  html_tag("TD", sprintf("<IMG src='%s%s'><br>\nLast Updated: %s\n", _DOC_ROOT, $rrd_graph, date("D M j G:i:s T Y", @filemtime(_ABS_ROOT . $rrd_graph))),
									  $color[3], "width=80% align=center"),
							 "", ""),
						 $color[10], "width=100% cellspacing=1 cellpadding=1"),
					 $color[3], ""),
				 "", "");
	} else {
		$graph = FALSE;
	}

	return $graph;
}


?>
