<?
/********************************************************************
Copyright (c) 2003 Jason Sessler

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
********************************************************************/

function load_host_config()
{
	if(function_exists("add_MenuItem")) {
		add_MenuItem("Host Groups", "main.location.href='modules/webconfig/configure.php?LOC=groups'", "ROOT/Config", TRUE, _GROUP_WRITE);
		add_MenuItem("Hosts", "main.location.href='modules/webconfig/configure.php?LOC=hosts'", "ROOT/Config", FALSE, _GROUP_WRITE);
		add_MenuItem("Checks", "main.location.href='modules/webconfig/configure.php?LOC=checks'", "ROOT/Config", FALSE, _ADMIN);
	}
	
	if(function_exists("add_QVLink")) {
		add_QVLink("WC_HG", "Host Groups", "modules/webconfig/configure.php?LOC=groups", FALSE, "Host Groups Configuration", _GROUP_WRITE, "ROOT/WC");
		add_QVLink("WC_H", "Hosts", "modules/webconfig/configure.php?LOC=hosts", FALSE, "Hosts Configuration", _GROUP_WRITE, "ROOT/WC");
		add_QVLink("WC_HC", "Checks", "modules/webconfig/configure.php?LOC=checks", FALSE, "Checks Configuration", _ADMIN, "ROOT/WC");
	}

	if(@function_exists("addModuleAction")) {
		addModuleAction(_VIEWHOST_MODULES, "Web Configuration", "showHostConfig");
	}

	if(function_exists("register_config")) {
		register_config("Host Groups", "hostconfig/configure.php", "groups", "Configure the primary host groups.", _GROUP_WRITE);
		register_config("Hosts", "hostconfig/configure.php", "hosts", "Configure the hosts. This should include assigning checks to specific hosts and all other host specific information.", _GROUP_WRITE);
		register_config("Checks", "hostconfig/configure.php", "checks", "Configure checks. Configure check types and default check options.", _ADMIN);
	}

	return TRUE;
}

function showHostConfig()
{
	global $args, $session;

	if($session->checkAccessLevel(_GROUP_WRITE)) {
		$link = sprintf("<A HREF='%s'>Edit</A>\n", buildURL(_DOC_ROOT . "/modules/webconfig/configure.php", array_merge($args, Array("LOC" => "hosts", "viewChecks" => 1, "action" => "edit"))));
	} else {
		$link = NULL;
	}

    return Array('link' => $link);
}

?>
