<?
/********************************************************************
Copyright (c) 2004 Rodney Caudle

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
********************************************************************/

/********************************************************************
	Changelog:
	03/01/2004 - Added templating in templates.inc.php
			moved it to a wizard without any restrictions
			on the number of steps
	02/17/2004 - initial build
			display the available hosts (sniffers) to
			select from for adding to their ruleset

********************************************************************/
require _ABS_ROOT . "/modules/idsadvconfig/idsadv.inc.php";
require_once _ABS_ROOT . "/modules/idsadvconfig/messages.inc.php";
require_once _ABS_ROOT . "/modules/idsadvconfig/variables.inc.php";
require_once _ABS_ROOT . "/modules/idsadvconfig/functions.inc.php";
require_once _ABS_ROOT . "/modules/idsadvconfig/templates.inc.php";
require_once _ABS_ROOT . "/modules/idsadvconfig/class_rule.php";

$IMAGE_ROOT = _DOC_ROOT . "/images";

$db = new conn_mySQL($credentials);
$db->db_new_conn();
	
if($LOC == "IDSADV") {
  switch($step)
  {
/********************************************************************
* Step 1: Select the host and version of snort to proceed with
********************************************************************/
    case "1":
      $message = $templates{"step1"};
      $message = str_replace("<<STEPMSG>>", $step1_message, $message);
      $message = str_replace("<<HOSTS>>", host_options($db), $message);
      printf("%s\n", $message);
      break;
/********************************************************************
* Step 2: Configure the variable section of this configuration 
********************************************************************/
    case "2":
      $message = $templates{"step2"};
      $message = str_replace("<<STEPMSG>>", $step2_message, $message);
      $defvar = get_section($db, $hostid, _SECTION_VAR);
      $message = str_replace("<<DEFAULTVARS>>", $defvar, $message);
      $message = str_replace("<<SHORT>>", $short, $message);
      $message = str_replace("<<HOSTID>>", $hostid, $message);
      $message = str_replace("<<HOSTNAME>>", host_name($db,$hostid), $message);
      $message = str_replace("<<VERSION>>", $version, $message);
      printf("%s\n", $message);
      break;
/********************************************************************
* Step 3: Choose the preprocessing parameters to use 
********************************************************************/
    case "3":
      if ($variables) { save_section($db, $hostid, _SECTION_VAR, $variables, 1); }
      $message = $templates{"step3"};
      $message = str_replace("<<STEPMSG>>", $step3_message, $message);
      $preproc = get_section($db, $hostid, _SECTION_PREPROC);
      $message = str_replace("<<PREPROC>>", $preproc, $message);
      $message = str_replace("<<SHORT>>", $short, $message);
      $message = str_replace("<<HOSTID>>", $hostid, $message);
      $message = str_replace("<<HOSTNAME>>", host_name($db,$hostid), $message);
      $message = str_replace("<<VERSION>>", $version, $message);
      printf("%s\n", $message);
      break;
/********************************************************************
* Step 4: choose groups to drill into, if checkbox "select individual rules" checked
*   then give the option to turn on/off individual rules
********************************************************************/
    case "4":
      if ($preproc) { save_section($db, $hostid, _SECTION_PREPROC, $preproc, 2); }
      $message = $templates{"step4"};
      $message = str_replace("<<STEPMSG>>", $step4_message, $message);
      $output = get_section($db, $hostid, _SECTION_OUTPUT);
      $message = str_replace("<<OUTPUT>>", $output, $message);
      $message = str_replace("<<SHORT>>", $short, $message);
      $message = str_replace("<<HOSTID>>", $hostid, $message);
      $message = str_replace("<<HOSTNAME>>", host_name($db,$hostid), $message);
      $message = str_replace("<<VERSION>>", $version, $message);
      printf("%s\n", $message);
      break;
/********************************************************************
* Step 5: Select rule groups to use with this configuration
*   - check the "select individual rules" to select individual rules
*     to use
********************************************************************/
    case "5":
      if ($output) { save_section($db, $hostid, _SECTION_OUTPUT, $output, 3); }
      $message = $templates{"step5"};
      $message = str_replace("<<STEPMSG>>", $step5_message, $message);
      $classification = get_section($db, $hostid, _SECTION_CLASS);
      $message = str_replace("<<CLASSIFICATION>>", $classification, $message);
      $message = str_replace("<<SHORT>>", $short, $message);
      $message = str_replace("<<HOSTID>>", $hostid, $message);
      $message = str_replace("<<HOSTNAME>>", host_name($db,$hostid), $message);
      $message = str_replace("<<VERSION>>", $version, $message);
      printf("%s\n", $message);
      break;
/********************************************************************
* Step 6: Select rule groups to use with this configuration
*   - check the "select individual rules" to select individual rules
*     to use
********************************************************************/
    case "6":
      if ($classification) { save_section($db, $hostid, _SECTION_CLASS, $classification, 4); }
      $message = $templates{"step6"};
      $message = str_replace("<<STEPMSG>>", $step6_message, $message);
      $tmp = "";
      $selbase = selectedrulebasegroups($db, $hostid);
      foreach (chosenrulebasegroups($db) as $group => $gid) {
        $tmp .= str_replace("<<NAME>>", $group, $rulebasegroup);
        if ($selbase{"$group"} == "$group") {
          $tmp = str_replace("<<SELECTED>>", " checked", $tmp);
        } else {
          $tmp = str_replace("<<SELECTED>>", "", $tmp);
        }
        $tmp = str_replace("<<ID>>", $gid, $tmp);
      }
      $message = str_replace("<<RULES>>", $tmp, $message);
      $message = str_replace("<<SHORT>>", $short, $message);
      $message = str_replace("<<HOSTID>>", $hostid, $message);
      $message = str_replace("<<HOSTNAME>>", host_name($db,$hostid), $message);
      $message = str_replace("<<VERSION>>", $version, $message);
      printf("%s\n", $message);
      break;
/********************************************************************
* Step 7: If individual is set, display all the rules for the 
*   $currentgroup and set the currentgroup value to the next group.
*   Set the othergroups to the remaining groups to be processed.
*   This step also processes the rules/groups when individual is set
*   but currentgroup is empty OR individual is not set at all.
*
*   If individual is not set then process all rules for the group(s)
*   that are selected.
********************************************************************/
    case "7":
      $message = $templates{"step7"};
      if ($individual == "on") {
//    First possibility, choose individual rules with something in the currentgroup variable
//    this means the second iteration through step #6... first iteration the currentgroup variable
//    isn't set yet
        if ((strlen($currentgroup) > 0) || (count(groupschosen()) > 0)) {
//        Fill in the other groups if needed (first time around only)
          if (strlen($currentgroup) == 0) { 
//          set the currentgroup to the first group found
            $tmp = groupschosen();
            $currentgroup = $tmp[0];
           // echo "currentgroup = $currentgroup<hr>\n";

//          Set the next currentgroup
            $message = str_replace("<<CURRENTGROUP>>", $tmp[1], $message);

//          Now save the other groups for later
            for ($x=2; $x<count($tmp); $x++) {
              if (strlen($others) < 1) { $others = $tmp[$x]; } else { $others .= "," . $tmp[$x]; }
            }

//          Set the othergroups for next round
            $message = str_replace("<<OTHERGROUPS>>", $others, $message);

          } else {
//        There's already an existing currentgroup so we don't have to set it
//        Save the remainding groups
            $tmp = split(",", $othergroups); 

//          Set the next currentgroup
            $message = str_replace("<<CURRENTGROUP>>", $tmp[0], $message);

//          Now save the other groups for later
            for ($x=1; $x<count($tmp); $x++) {
              if (strlen($others) < 1) { $others = $tmp[$x]; } else { $others .= "," . $tmp[$x]; }
            }

//          Set the othergroups for next round
            $message = str_replace("<<OTHERGROUPS>>", $others, $message);
          }

//        Get any saved rule choices from the DB
          $oldchoices = savedrules($hostid,$currentgroup);

//        Build the current set of rules to choose from
          foreach (grouprules($currentgroup) as $key => $name) {
            $rules .= str_replace("<<ID>>", $key, $rulebaseline);
            $rules = str_replace("<<NAME>>", $name, $rules);
            if (strlen($oldchoices{"$key"}) > 0) {
              $rules = str_replace("<<SELECTED>>", " checked", $rules);
            } else {
              $rules = str_replace("<<SELECTED>>", "", $rules);
            }
          }

//      Save any existing choices that have been made for next round
//        these choices are collected at the end of the iterations.
          $tmp = "";
          foreach ($_POST as $key => $value) {
            if (strstr($key, "rule_")) {
//              echo "$key => $value<hr>\n";
              if (empty($tmp)) {
                $tmp = str_replace("<<ID>>", substr($key,5), $rulebasesave);
              } else {
                $tmp .= str_replace("<<ID>>", substr($key,5), $rulebasesave);
              }
              $tmp = str_replace("<<VALUE>>", $value, $tmp);
            }
          }

//        Now set the rest of the variables
          $message = str_replace("<<HOSTID>>", $hostid, $message);
          $message = str_replace("<<SHORT>>", $short, $message);
          $message = str_replace("<<VERSION>>", $version, $message);
          $message = str_replace("<<STEPMSG>>", $step7_message, $message);
          $message = str_replace("<<RULESSAVE>>", $tmp, $message);
          $message = str_replace("<<RULES>>", $rules, $message);
          $message = str_replace("<<INDIVIDUAL>>", $individual, $message);

//        And finally print!
          printf("%s\n", $message);

        } else {
//      Second possibility, either no groups selected or no groups left and this is the last iteration of the loop
//      Either way we'll act like it's the last iteration... if they chose no groups then we'll just process any 
//      available rule_XX variables and turn off the rest.  If no groups are chosen then no rules will be selected for
//      that host.

//        Save all the existing choices... rules first, disable any of them that aren't chosen...
          $choices = rulebaserids($db);
          $norules = true;
          foreach($choices as $key => $rule) {
            if (strlen(${"rule_" . $key}) > 0) { 
              processChoice($db, $hostid, $key, true); 

//            Apparently some rules were found so set this to true.
              if ($norules) { $norules = false; }

            } else {
//            This rule wasn't selected so turn it off
              processChoice($db, $hostid, $key, false); 

            }
            $rules .= $rule . "\n";
          }

//        Set the status for HID to FULLY_CONFIGURED
          setStatus($hostid, "FULLY_CONFIGURED");

//        Print the "thanks for playing" message
          $message = str_replace("<<STEPMSG>>", $step7_done, $templates{"step7_done"});
          if ($norules) { 
            $message = str_replace("<<WARNING>>", $step7_warning, $message); 
          } else { 
            $message = str_replace("<<WARNING>>", "", $message); 
          }
          printf("%s\n", $message);

        }
      } else {
//    Third possibility, individual not selected... process all available groups to see if any are selected
//    display no-groups warning on completion page if no groups selected. 

//      Get a list of all the group IDs available
        $choices = rulebasegids(false);
        $nogroups = true;
 
//      Look for each groupID to see if it was selected
        foreach($choices as $gid => $gname) {
//          echo "Testing group #$gid as $gname...";
          if (isset(${"group_" . $gid})) {			// This means it was selected...
//            echo "chosen<hr>\n";
            foreach(grouprules($gid) as $key => $rname) {
              processChoice($db, $hostid, $key, true);
            }
          } else {
//            echo "not chosen<hr>\n";
            foreach(grouprules($gid) as $key => $rname) {
              processChoice($db, $hostid, $key, false);
            }
          }
        }
//      Set the status for HID to FULLY_CONFIGURED
        setStatus($hostid, "FULLY_CONFIGURED");

        $message = str_replace("<<STEPMSG>>", $step7_done, $templates{"step7_done"});
        $message = str_replace("<<WARNING>>", "", $message); 
        printf("%s\n",$message);
      }
      break;
/*
** Default Option... no steps chosen, display the verbage
**   but there's also the option of viewing the details of a rule
*/
    default:
      switch ($type) {
        case "view": 
          $message = view_rule_details($db,$rid,$rulebasedetails);
          printf("%s\n", $message);
          break;
        case "viewgroup":
          $message = view_rule_group_details($db,$group,$rulegroupdetails);
          printf("%s\n", $message);
          break;
        case "new":
          $message = str_replace("<<GROUPS>>", rulebasegroups(true), $templates{"new_rule_page"});
          printf("%s\n", $message);
          break;
        case "newgroup":
          printf("%s\n", $templates{"new_group_page"});
          break;
        case "procnewrule":
          if (processNewRule()) { $message = "new_rule_success"; } else { $message = "new_rule_failure"; }
          printf("%s\n", $templates{"$message"});
          break;
        case "procnewgroup":
          if (processNewGroup()) { $message = "new_group_success"; } else { $message = "new_group_failure"; }
          printf("%s\n", $templates{"$message"});
          break;
        case "edit":
          $message = str_replace("<<RULES>>", rulestoedit(_EDIT_ONLY_CUSTOM_RULES), $templates{"edit_rule_page"});
          if ((strlen($rid) > 0) && ($rid !== "0")) {
            $tmprule = new rule;
            //$tmprule->toggleDebug();
            $tmprule->setRID($rid);
            if ($tmprule->retrieveRule()) {
              $message = str_replace("<<DETAILS>>", $tmprule->printEdit(), $message);
            } else {
              $message = str_replace("<<DETAILS>>", "", $message);
            }
          } else {
            $message = str_replace("<<DETAILS>>", "", $message);
          }
          printf("%s\n", $message);
          break;
        case "editrule":
          if (isset($rid) && isset($category) && isset($name) && isset($description) &&
              isset($rule2_0) && isset($rule2_1)) {
            $tmprule = new rule;
            $tmprule->setRID($rid);
            $tmprule->setCategory($category);
            $tmprule->setDescription($description);
            $tmprule->setName($name);
            $tmprule->setEnabled($enabled);
            $tmprule->addVersion("Rule2_0", $rule2_0);
            $tmprule->addVersion("Rule2_1", $rule2_1);
            if ($tmprule->updateDB()) {
              $message = $templates{"edit_rule_success"};
            } else {
              $message = $templates{"edit_rule_failure"};
            }
          } else {
            $message = $templates{"edit_rule_failure"};
          }
          printf("%s\n", $message);
          break;
	case "viewstatus":
          $message = str_replace("<<HOSTS>>", hostsstatus(), $templates{"view_status_page"});
          printf("%s\n", $message);
          break;
        case "delete":
          $message = str_replace("<<HOSTS>>", hostschoices(), $templates{"delete"});
          printf("%s\n", $message);
          break;
        case "deleteconfig":
          $message = configclear($hostid);
          printf("%s\n", $message);
          break;
        default:
          printf("%s\n", $loc_message);
          break;
      }
      break;
  }
}

$db->clear_res();
$db->db_close();
$db = NULL;
?>
