<?
/********************************************************************
Copyright (c) 2004 Rodney Caudle

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
********************************************************************/

/********************************************************************
	Changelog:
	02/10/2004  -   Initial Creation based on idsconfig by
			Jason Sessler
********************************************************************/

require_once _ABS_ROOT . "/modules/idsadvconfig/idsadv.inc.php";

function load_idsadv_config()
{
	/* Define some global variables to use */
	define("_TABLE_SNORT_RULEBASE", "MIDAS_SNORT_Rulebase");
	define("_TABLE_SNORT_SECTIONS", "MIDAS_SNORT_Sections");
	define("_TABLE_SNORT_HOST_MAPPING", "MIDAS_SNORT_HID_x_RID");
	define("_TABLE_SNORT_MAPPING", "MIDAS_SNORT_Mapping");
	define("_TABLE_SNORT_GROUPS", "MIDAS_SNORT_Groups");
	define("_TABLE_SNORT_STATUS", "MIDAS_SNORT_Status");
        define("_SECTION_VAR", "VARIABLES");
        define("_SECTION_PREPROC", "PREPROC");
        define("_SECTION_OUTPUT", "OUTPUT");
        define("_SECTION_CLASS", "CLASS");
	define("_DEFAULT_CUSTOM_SNORT_GROUP", "CUSTOM-RULES");
	define("_EDIT_ONLY_CUSTOM_RULES", false);

	/* Add a link to the main menus at the top */
	if(@function_exists("add_MenuItem")) {
		add_MenuItem("IDS Advanced Configuration", 
			"main.location.href='modules/webconfig/configure.php?LOC=IDSADV'", 
			"ROOT/Config", TRUE, _ADMIN);
		add_MenuItem("New Custom IDS Rule", 
			"main.location.href='modules/webconfig/configure.php?LOC=IDSADV&type=new'", 
			"ROOT/Config", FALSE, _ADMIN);
		add_MenuItem("New Custom IDS Group", 
			"main.location.href='modules/webconfig/configure.php?LOC=IDSADV&type=newgroup'", 
			"ROOT/Config", FALSE, _ADMIN);
		add_MenuItem("Edit an IDS Rule", 
			"main.location.href='modules/webconfig/configure.php?LOC=IDSADV&type=edit'", 
			"ROOT/Config", FALSE, _ADMIN);
		add_MenuItem("View IDS Status", 
			"main.location.href='modules/webconfig/configure.php?LOC=IDSADV&type=viewstatus'", 
			"ROOT/Config", FALSE, _ADMIN);
		add_MenuItem("Delete Sensor Configuration", 
			"main.location.href='modules/webconfig/configure.php?LOC=IDSADV&type=delete'", 
			"ROOT/Config", FALSE, _ADMIN);
	}

	/* Add a link to the QuickView section */
	if(@function_exists("add_QVLink")) {
		add_QVLink("WC_IDSADV", "IDS Advanced", 
			"modules/webconfig/configure.php?LOC=IDSADV", FALSE, 
			"IDS Rules Advanced Configuration", _ADMIN, "ROOT/WC");
	}

	/* Add a hook for the configuration parameters */
	if(@function_exists("register_config")) {
		register_config("Intrusion Detection Advanced", "idsadvconfig/configure.php", "IDSADV", 
			"Configure the SNORT IDS rule sets and the Snort configurations for your SNORT sensors using the Advanced Interface.", _ADMIN);
	}

	return TRUE;
}

?>
