<?php
/********************************************************************
* Step 1 messages 
********************************************************************/
$step1_message = <<<DONEDONEDONE
  <span class="titlelarge">Step 1: Choosing the version and host</span><br><br>

  <span class="bodysmall">Select the host that this SNORT configuration will effect from the available hosts.  
    Please note that only hosts designated as SNIFFER hosts in the Hosts Configuration.</span><br><br>

  <span class="bodysmall">Select the version of SNORT that the host above is running.  All versions of SNORT 
     past 2.0.0 are supported currently.  This information is used to provide an accurate list of preprocessors
     and output plugins available for SNORT.  Syntax and plugins change with each version so maintaining
     a list is important.  If you would like your version added to this list please contact us or post it
     to the Forums and we'll add it in here. </span><br><br>

  <span class="bodysmall">Choose to receive the short version or long version of selections coming up.  The short 
     version is usually the minimalistic version of options without any comments.  If you don't want the short 
     version then leave this option unchecked and you'll receive the longer version which includes extensive comments
     and explanations of the options.  We recommend the short version and to reference the website for further
     explanation of the choices.</span>
DONEDONEDONE;
$step1_short = <<<DONEDONEDONE
<span class="blackmid">Step 1: Choosing the version and host<br></span>
DONEDONEDONE;

/********************************************************************
* Step 2 messages 
********************************************************************/
$step2_message = <<<DONEDONEDONE
  <span class="titlelarge">Step 2: Setup Network Variables</span><br><br>

  <span class="bodysmall">During this step you will define the variables that will be used in the rules
    sent to your SNORT installation on <<HOSTNAME>>.  If a configuration for <<HOSTNAME>> is available 
    this wizard will display your saved configuration to modify.  If <<HOSTNAME>> does not have a 
    saved configuration then the default set of variables will be presented as a starting point.</span><br><br>

  <span class="bodysmall">The default set of variables are needed for the standard Rulebase to work.  
    During the first visit for <<HOSTNAME>> the default variables have initial values which can be modified
    to suit your network.  Please note that (at this time) no additional qualification is done with the 
    variables.  Future versions may attempt to qualify the content of this statement but at this time we don't
    save you from yourself... be careful not to break SNORT with this statement.</span><br><br>
  
  <span class="bodysmall">You can create any variables that you like.  The syntax is:<br>
    <pre>var VARIABLENAME VALUE</pre>
    Where the VALUE can be either a list of IPs or a single value.  Please check 
    <a href="http://www.snort.org/docs/snort_manual/node10.html#SECTION00312100000000000000">snort.org documentation</a> 
     for more details on the specifics of variables.</span>
DONEDONEDONE;
$step2_short = <<<DONEDONEDONE
  <span class="blackmid">Step 2: Setup Network Variables<br></span>
DONEDONEDONE;

/********************************************************************
* Step 3 messages 
********************************************************************/
$step3_message = <<<DONEDONEDONE
  <span class="titlelarge">Step 3: Configure Preprocessors</span><br><br>

  <span class="bodysmall">During this step you will define the preprocessors which will be loaded into
    <<HOSTNAME>>.  These processors depend on the version of SNORT chosen in step #1.  If you don't see
    the correct listing of preprocessors for your version of SNORT simply rerun the wizard with the
    correct version chosen.</span>

  <span class="bodysmall">Please note that (at this time) no additional qualification is done with the 
    preprocessors.  Future versions may attempt to qualify the content of this statement but at this time we don't
    save you from yourself... be careful not to break SNORT with this statement.</span><br><br>
DONEDONEDONE;
$step3_short = <<<DONEDONEDONE
  <span class="blackmid">Step 3: Configure Preprocessors<br></span>
DONEDONEDONE;

/********************************************************************
* Step 4 messages 
********************************************************************/
$step4_message = <<<DONEDONEDONE
  <span class="titlelarge">Step 4: Configure Output Plugins</span><br><br>

  <span class="bodysmall">During this step you will define the output plugins which will be loaded into
    <<HOSTNAME>>.  These output plugins depend on the version of SNORT chosen in step #1.  If you don't
    see the correct listing of output plugins for your version of SNORT simply rerun the wizard with the
    correct version chosen.</span>
<br><br>
  <span class="bodysmall">Please note that (at this time) no additional qualification is done with the 
    output plugins.  Future versions may attempt to qualify the content of this statement but at this time we don't
    save you from yourself... be careful not to break SNORT with this statement.</span>
DONEDONEDONE;
$step4_short = <<<DONEDONEDONE
  <span class="blackmid">Step 4: Configure Output Plugins<br></span>
DONEDONEDONE;

/********************************************************************
* Step 5 messages 
********************************************************************/
$step5_message = <<<DONEDONEDONE
  <span class="titlelarge">Step 5: Configure Classifications</span><br><br>

  <span class="bodysmall">During this step you will define the types of classifications which are to be
    used with <<HOSTNAME>>.  These classifications depend on the rules being used and can be
    added to if desired.  By default the classifications that are needed with the default ruleset
    are added.  If you have special classifications in mind for your custom rulesets ensure they are
    added to this section.  
    </span>
<br><br>
  <span class="bodysmall">Please note that (at this time) no additional qualification is done with the 
    classifications.  Future versions may attempt to qualify the content of this statement but at this time we don't
    save you from yourself... be careful not to break SNORT with this section.  An unknown classification
    will result in SNORT being unable to load.</span>
<br><br>
  <span class="bodysmall">SYNTAX: config classification:<i>shortname,short description,priority</i><br>
    example: config classification: policy-violation,Potential Corporate Privacy Violation,1</span>
DONEDONEDONE;

$step5_short = <<<DONEDONEDONE
  <span class="blackmid">Step 5: Configure Classifications<br></span>
DONEDONEDONE;
/********************************************************************
* Step 6 messages 
********************************************************************/
$step6_message = <<<DONEDONEDONE
  <span class="titlelarge">Step 5: Customize Ruleset</span><br><br>

  <span class="bodysmall">During this step you will choose the rules and groups of rules to use
     for <<HOSTNAME>>.  To view more detailed information about a specific rule or group of rules
     just click on the "view" link.  A window will popup with additional information for you.</span><br><br>

  <span class="bodysmall">The rules only change for major release version of SNORT (v2.0.x versus v2.1.x)
     so based on the choice you give, you'll be selecting the appropriate rule for your SNORT version.
     If you are using a version of SNORT not represented here please send us an email or post it to the
     forums section and we'll get it into the next release.</span><br><br>

  <span class="bodysmall">Custom rules start at number 1,000,000 and proceed upwards.  You can create custom
     rules for the Rulebase by choosing "Config->New IDS Custom Rule" from the drop down menus.  The custom 
     rules are automatically numbered for you and included in a group called CUSTOM-RULES.  Future support will
     support custom rule groups for categorizing your custom rules.</span>
DONEDONEDONE;
$step6_short = <<<DONEDONEDONE
<span class="blackmid">Step 6: Customize Your Ruleset<br></span>
DONEDONEDONE;

/********************************************************************
* Step 7 messages 
********************************************************************/
$step7_message = <<<DONEDONEDONE
  <span class="titlelarge">Step 6: Select Individual Rules</span><br><br>

  <span class="bodysmall">During this step you will choose the rules to use for each group selected in step 5.
     To view more detailed information about a specific rule or group of rules just click on the "view" link.  
     A window will popup with additional information for you.</span><br><br>

  <span class="bodysmall">Custom rules start at number 1,000,000 and proceed upwards.  You can create custom
     rules for the Rulebase by choosing "Config->New IDS Custom Rule" from the drop down menus.  The custom 
     rules are automatically numbered for you and included in a group called CUSTOM-RULES.  Future support will
     support custom rule groups for categorizing your custom rules.</span>
DONEDONEDONE;

$step7_done = <<<DONEDONEDONE


  <<WARNING>>

  <p>The configuration of SNORT for use with MIDASs is completed.  You will need to restart
     MIDASs to ensure the new ruleset is loaded.</p>
   </TD>
  </TR></TABLE>
 </TD>
</TR></TABLE>
DONEDONEDONE;

$step7_warning = <<<DONEDONEDONE
  <span class="bodysmall"><font color="red">No rules were selected!!  The ruleset for this SNORT sensor has been
     erased!  Please ensure that you return to step 6 to select rules as soon as possible!</span><br><br>
DONEDONEDONE;

/********************************************************************
* Other messages 
********************************************************************/
$loc_message = <<<DONEDONEDONE
<TABLE bgcolor=#E0E0E0 width=95% cellspacing=0 cellpadding=1 align=center>
<TR>
 <TD bgcolor=#83A0BA class='blacksmall' align=center><b>MIDASs Sensor Configuration</b></TD>
</TR>
<TR>
 <TD bgcolor=#376589 align="center">
  <TABLE bgcolor=#E0E0E0 width=100% cellspacing=1 cellpadding=3 align=center>
  <TR>
   <TD bgcolor=#E0E0E0 width=100% valign=top align=center>
  $step1_short
  $step2_short
  $step3_short
  $step4_short
  $step5_short
  $step6_short
  </td></tr><tr><td align="right">
  <form method="POST" action="configure.php?LOC=IDSADV&step=1" name="configform">
    <input type="submit" value="START">
  </form>
  </td></tr></table>
</td></tr></table>
DONEDONEDONE;

$rulebasehead = <<<DONEDONEDONE
<tr><td colspan="3" bgcolor="black">
 <table border="0" bgcolor="white" width="100%">
  <tr><td class="blackmid" align="center"><<CATEGORY>></td></tr>
 </table>
</td></tr><tr><td colspan="3" bgcolor="black">
 <table width="100%" border="0" bgcolor="white">
  <<RULES>>
 </table>
</td></tr>
DONEDONEDONE;

$rulebaseline = <<<DONEDONEDONE
<tr>
 <td class="bodysmall"><input type="checkbox" name="rule_<<ID>>"<<SELECTED>>></td>
 <th align="left" class="bodysmall"><<NAME>></th>
 <td width="25" class="bodysmall" align="right"><a href="configure.php?LOC=IDSADV&type=view&rid=<<ID>>" target="__totallynew__">view</a></td>
</tr>
DONEDONEDONE;

$rulebasesave = <<<DONEDONEDONE
<input type="hidden" name="rule_<<ID>>" value="<<VALUE>>">
DONEDONEDONE;

$rulebasegroup = <<<DONEDONEDONE
<tr>
 <td class="bodysmall"><input type="checkbox" name="group_<<ID>>"<<SELECTED>>></td>
 <th align="left" class="bodysmall"><<NAME>></th>
 <td width="25" class="bodysmall" align="right"><a href="configure.php?LOC=IDSADV&type=viewgroup&group=<<NAME>>" target="__totallynew__">view</a></td>
</tr>
DONEDONEDONE;

$rulebasedetails = <<<DONEDONEDONE
<TABLE bgcolor=#E0E0E0 width=95% cellspacing=0 cellpadding=1 align=center>
<TR>
 <TD bgcolor=#83A0BA class='blacksmall' align=center><b>Rule #<<ID>></b></TD>
</TR>
<TR>
 <TD bgcolor=#376589 align="center">
  <TABLE bgcolor=#E0E0E0 width=100% cellspacing=1 cellpadding=3 align=center>
  <TR>
   <TD bgcolor=#E0E0E0 width=100% valign=top align=center>
 <table width="100%" border="0" cellpadding="5" cellspacing="1">
 <tr><th>Category</th><td><<CATEGORY>></td></tr>
 <tr><th>RID</th><td><<ID>></td></tr>
 <tr><th>Name</th><td><<NAME>></td></tr>
 <tr><th>Enabled</th><td><<ENABLED>></td></tr>
 </tr><tr><th>Rules</th><td>
  <table width="100%" border="0" cellpadding="5" cellspacing="1">
   <tr><td><b>Version 2.0.x</b><br><<RULE20>></td></tr>
   <tr><td><b>Version 2.1.x</b><br><<RULE21>></td></tr>
 </table>
 </td></tr>
  <tr><th valign="top">Description</th><td><<DESCRIPTION>></td></tr>
</td></tr></table>
</td></tr></table>
DONEDONEDONE;
?>
