<?
/********************************************************************
Copyright (c) 2004 Tom Cashmore

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
********************************************************************/

function netmonsessions_summary_history()
{
	global $args;
	global $netmonsesNumToList;
	global $netmonsesStartList;
	global $netmonsesSrcIP;
	global $netmonsesDstIP;
	global $netmonsesDstPort;
	global $netmonsesExpandSession;
	global $netmonsesOrder;

	if(!intval($netmonsesOrder))
	{
		$netmonsesOrder = 5;
	}
		
	if(!intval($netmonsesStartList))
	{
		$netmonsesStartList = 0;
	}
		
	if(!intval($netmonsesNumToList))
	{
		$netmonsesNumToList = 10;
	}
		
	$args = array_merge($args, array("netmonsesOrder" => $netmonsesOrder));
	
	$Output = netmonsessions_build_history("Most Active Network Sessions", "95%");

	echo "$Output\n";

	return(TRUE);
}

function netmonsessions_host_history()
{
	global $showNetMonSessions;
	global $args;
	global $_SERVER;
	
	if($showNetMonSessions == 1) 
	{
		$ToggleValue = 0;
		$Label = "Hide";
		$Output = netmonsessions_build_history("Network Sessions", "100%");
	} else {
		$ToggleValue = 1;
		$Label = "Show";
		$Output = "";
	}
	
	$URL = "<A HREF='". buildURL(_DOC_ROOT . "/view_host.php", array_merge($args, Array("showNetMonSessions" => $ToggleValue))) ."'>$Label</a>";
	return array('link' => $URL, 'output' => $Output);
}

function netmonsessions_build_history($TableTitle, $TableWidth)
{
	global $args;
        global $_SERVER;
	global $db;
	global $color;
	global $HID;
	global $netmonsesNumToList;
	global $netmonsesStartList;
	global $netmonsesSrcIP;
	global $netmonsesDstIP;
	global $netmonsesDstPort;
	global $netmonsesExpandSession;
	global $netmonsesOrder;
	
	$CleanPHPSelf = str_replace("//", "/", $_SERVER['PHP_SELF']);

	define("_TABLE_NETMON_SESSIONS", "MIDAS_NetMon_Sessions");

	if($db->dbc) 
	{
		$mon = new conn_mySQL();
		$mon->db_use_conn($db->dbc, $db->db);
		$closeit = FALSE;
	} else {
		global $credentials;
		$mon = new conn_mySQL($credentials);
		$mon->db_new_conn();
		$closeit = TRUE;
	}

	$SQLWhere = "";
	if($HID > 0)
	{
		$mon->query = "SELECT IPAddr FROM MIDAS_Hosts WHERE HID='$HID'";
		$mon->run_query();
		if($mon->rows)
		{
			$mon->step();
			$IPAddress = gethostbyname($mon->res['IPAddr']);
			if($IPAddress)
			{
				$SQLWhere = "WHERE SrcIP='$IPAddress' OR DstIP='$IPAddress'";
			}
		}
		$mon->clear_res();
	}
	
	$mon->query = "SELECT DISTINCT SrcIP, DstIP, DstPort, SUM(PacketCount), SUM(Bytes), MIN(UNIX_TIMESTAMP(StartTime)), MAX(UNIX_TIMESTAMP(EndTime)), Protocol, COUNT(EndTime)
			FROM MIDAS_NetMon_Sessions
			$SQLWhere
			GROUP BY SrcIP, DstIP, DstPort";
	$mon->run_query();
	$TotalRecords = $mon->rows;
	$mon->clear_res();
	
	if(!intval($netmonsesOrder))
	{
		$netmonsesOrder = 7;
	}
		
	if(!intval($netmonsesStartList))
	{
		$netmonsesStartList = 0;
	}
		
	if(!intval($netmonsesNumToList))
	{
		$netmonsesNumToList = 10;
	}
		
	$args = array_merge($args, array("netmonsesOrder" => $netmonsesOrder));
		
	$mon->query = "SELECT DISTINCT SrcIP, DstIP, DstPort, SUM(PacketCount), SUM(Bytes), MIN(UNIX_TIMESTAMP(StartTime)), MAX(UNIX_TIMESTAMP(EndTime)), Protocol, COUNT(EndTime)
			FROM MIDAS_NetMon_Sessions
			$SQLWhere
			GROUP BY SrcIP, DstIP, DstPort
			ORDER BY UpdateCount, $netmonsesOrder DESC
			LIMIT $netmonsesStartList, $netmonsesNumToList";
	$mon->run_query();
	
	if($mon->rows)
	{
		$showList = Array("1"   => 1, 
				  "5"   => 5, 
				  "10"  => 10, 
				  "20"  => 20,
				  "30"  => 30, 
				  "40"  => 40, 
				  "50"  => 50, 
				  "100" => 100);
					 
		for($i=0;$i<$mon->rows;$i++)
		{
			$mon->step();
				
			if($mon->res['SrcIP'] == $netmonsesSrcIP && 
			   $mon->res['DstIP'] == $netmonsesDstIP && 
			   $mon->res['DstPort'] == $netmonsesDstPort &&
			   $netmonsesExpandSession == 1)
			{
				$Toggle = 0;
				$Image = "open.gif";
				$Expand = 1;
			} else {
				$Toggle = 1;
				$Image = "unopen.gif";
				$Expand = 0;
			}
			
			$URL = "<A HREF='". buildURL($CleanPHPSELF, array_merge($args, array("netmonsesSrcIP" => $mon->res['SrcIP'], "netmonsesDstIP" => $mon->res['DstIP'], "netmonsesDstPort" => $mon->res['DstPort'], "netmonsesExpandSession" => "$Toggle"))) ."'>";
			$URL .= "<img border=0 src='modules/netmonsessions/images/$Image'></a>";
							
			$items .= html_tag("TR",
					html_tag("TD", $URL, $color[12], "align=center valign=top class=blacksmall") .
					html_tag("TD", $mon->res['SrcIP'], $color[12], "align=center valign=top class=blacksmall") .
					html_tag("TD", $mon->res['DstIP'], $color[12], "align=center valign=top class=blacksmall") .
					html_tag("TD", $mon->res['DstPort'], $color[12], "align=center valign=top class=blacksmall") .
					html_tag("TD", netmonsessions_PrettyNumbers($mon->res['SUM(PacketCount)']), $color[12], "align=center valign=top class=blacksmall") .
					html_tag("TD", netmonsessions_PrettyNumbers($mon->res['SUM(Bytes)']), $color[12], "align=center valign=top class=blacksmall") .
					html_tag("TD", $mon->res['Protocol'], $color[12], "align=center valign=top class=blacksmall") .
					html_tag("TD", date("Y-m-d H:i:s", $mon->res['MIN(UNIX_TIMESTAMP(StartTime))']), $color[12], "align=center valign=top class=blacksmall") .
					html_tag("TD", date("Y-m-d H:i:s", $mon->res['MAX(UNIX_TIMESTAMP(EndTime))']), $color[12], "align=center valign=top class=blacksmall") .
					html_tag("TD", $mon->res['COUNT(EndTime)'], $color[12], "align=center valign=top class=blacksmall"),
				"", "");
			if($Expand)
			{
				$mon2 = new conn_mySQL();
				$mon2->db_use_conn($db->dbc, $db->db);
					
				$mon2->query = "SELECT SrcPort, PacketCount, Bytes, UNIX_TIMESTAMP(StartTime), UNIX_TIMESTAMP(EndTime), MIDAS_Hosts.Hostname
							FROM MIDAS_NetMon_Sessions, MIDAS_Hosts
							WHERE SrcIP='". $mon->res['SrcIP'] ."' AND DstIP='". $mon->res['DstIP'] ."' AND DstPort='". $mon->res['DstPort'] ."' AND Protocol='". $mon->res[Protocol] ."' AND MIDAS_NetMon_Sessions.HID=MIDAS_Hosts.HID
							ORDER BY EndTime DESC";
				$mon2->run_query();
				if($mon2->rows)
				{ 	
					$items .= "<TR><TD COLSPAN=10>\n";
					$items .= "<TABLE bgcolor=$color[10] width=100% cellspacing=1 cellpadding=3>\n";
						
					$items .= html_tag("TR",
							html_tag("TD", "<nobr><b>Source Port</b></nobr>", $color[0], "class='blacksmall' align=center") .
							html_tag("TD", "<nobr><b>Packet Count</b></nobr>", $color[0], "class='blacksmall' align=center") .
							html_tag("TD", "<nobr><b>Bytes</b></nobr>", $color[0], "class='blacksmall' align=center") .
							html_tag("TD", "<nobr><b>Start Time</b></nobr>", $color[0], "class='blacksmall' align=center") .
							html_tag("TD", "<nobr><b>End Time</b></nobr>", $color[0], "class='blacksmall' align=center") .
							html_tag("TD", "<nobr><b>Sensor</b></nobr>", $color[0], "class='blacksmall' align=center"),
						"", "");

					for($ii=0;$ii<$mon2->rows;$ii++)
					{
						$mon2->step();
						
						$items .= html_tag("TR",
								html_tag("TD", $mon2->res[SrcPort], $color[12], "align=center valign=top class=blacksmall") .
								html_tag("TD", netmonsessions_PrettyNumbers($mon2->res[PacketCount]), $color[12], "align=center valign=top class=blacksmall") .
								html_tag("TD", netmonsessions_PrettyNumbers($mon2->res[Bytes]), $color[12], "align=center valign=top class=blacksmall") .
								html_tag("TD", date("Y-m-d H:i:s", $mon2->res['UNIX_TIMESTAMP(StartTime)']), $color[12], "align=center valign=top class=blacksmall") .
								html_tag("TD", date("Y-m-d H:i:s", $mon2->res['UNIX_TIMESTAMP(EndTime)']), $color[12], "align=center valign=top class=blacksmall") .
								html_tag("TD", $mon2->res[Hostname], $color[12], "align=center valign=top class=blacksmall"),
							"","");
					}
					$items .= "</TABLE></TD></TR>\n";
				}
				$mon2->clear_res();
			}	

		}
	} else {
		$items .= html_tag("TR",
				html_tag("TD", "No Sessions Found", $color[12], "align=center valign=top class=blacksmall colspan=10"),
			"","");
	}
		
	$mon->clear_res();
		
	if($closeit)
	{
		$mon->db_close();
	}

	$table .= "<br><TABLE bgcolor='$color[10]' width=$TableWidth, cellspacing=1 cellpadding=1 align=center>";
	$table .= html_tag("TR",
                          	html_tag("TD", "<b>$TableTitle</b>\n", $color[9], "class=blacksmall align=center"), 
			"", "");
	$table .= html_tag("TR",
			html_tag("TD",
				"<FORM method=get action='$CleanPHPSELF'>\n" .
				"<SPAN class='blacksmall'><b>Show Last " . 
				build_select("netmonsesNumToList", $showList, $netmonsesNumToList) . 
				"Event(s)</b></SPAN>&nbsp;&nbsp;<input type=submit value='Go'>\n" .
 				buildHiddenValues("ShowNetMonSessions") ."</FORM>\n", 
				$color[12], "colspan=10 class=blacksmall align=center"),
			"", "");


	$table .= html_tag("TR",
			html_tag("TD",
				html_tag("TABLE", 
					html_tag("TR",
						html_tag("TD", "+", $color[0], "class='blacksmall' align=center") .
						html_tag("TD", "<nobr><b><a href='". BuildURL($CleanPHPSELF, array_merge($args, array("netmonsesOrder" => 1))) ."'>Source IP</a></b></nobr>", $color[0], "class='blacksmall' align=center") .
						html_tag("TD", "<nobr><b><a href='". BuildURL($CleanPHPSELF, array_merge($args, array("netmonsesOrder" => 2))) ."'>Destination IP</a></b></nobr>", $color[0], "class='blacksmall' align=center") .
						html_tag("TD", "<nobr><b><a href='". BuildURL($CleanPHPSELF, array_merge($args, array("netmonsesOrder" => 3))) ."'>Port</a></b></nobr>", $color[0], "class='blacksmall' align=center") .
						html_tag("TD", "<nobr><b><a href='". BuildURL($CleanPHPSELF, array_merge($args, array("netmonsesOrder" => 4))) ."'># of Packets</a></b></nobr>", $color[0], "class='blacksmall' align=center") .
						html_tag("TD", "<nobr><b><a href='". BuildURL($CleanPHPSELF, array_merge($args, array("netmonsesOrder" => 5))) ."'>Total Bytes</a></b></nobr>", $color[0], "class='blacksmall' align=center") .
						html_tag("TD", "<nobr><b><a href='". BuildURL($CleanPHPSELF, array_merge($args, array("netmonsesOrder" => 8))) ."'>Protocol</a></b></nobr>", $color[0], "class='blacksmall' align=center") .
						html_tag("TD", "<nobr><b><a href='". BuildURL($CleanPHPSELF, array_merge($args, array("netmonsesOrder" => 6))) ."'>Start Time</a></b></nobr>", $color[0], "class='blacksmall' align=center") .
						html_tag("TD", "<nobr><b><a href='". BuildURL($CleanPHPSELF, array_merge($args, array("netmonsesOrder" => 7))) ."'>End Time</a></b></nobr>", $color[0], "class='blacksmall' align=center") .
						html_tag("TD", "<nobr><b><a href='". BuildURL($CleanPHPSELF, array_merge($args, array("netmonsesOrder" => 9))) ."'># of Sessions</a></b></nobr>", $color[0], "class='blacksmall' align=center"),
					"", "") .
					$items .
					html_tag("TR",
						html_tag("TD",
							pageinate($CleanPHPSELF, $TotalRecords, Array("Start" => Array("netmonsesStartList" => $netmonsesStartList), "Size" => Array("netmonsesNumToList" => $netmonsesNumToList))),
							$color[3], "colspan=10 aligh=left"),
						"", ""),
				$color[10], "width=100% cellspacing=1 cellpadding=3"),
			$color[3], ""),
		"", "");
	$table .= "</table>";
		
	return($table);
}

function netmonsessions_PrettyNumbers($Number)
{
	$SIZELETTER[1] = "K";
	$SIZELETTER[2] = "M";
	$SIZELETTER[3] = "G";
	
	if(intval($Number))
	{
		$Size = intval((strlen($Number)-1) / 3);

		if($Size > 0)
		{	
			$Number = substr($Number, 0, strlen($Number) - $Size * 3) . $SIZELETTER[$Size];
		}
	}
	
	return($Number);
}

?>
