<?
/********************************************************************
Copyright (c) 2003 Jason Sessler

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
********************************************************************/

function load_qv_host_listing()
{
	if(function_exists("add_QVLink")) {
	    add_QVLink("HV", "Host View", "view_group.php", FALSE, "QuickView Host Viewer");
	    load_host_list("HV");
	} else {
		return TRUE;
	}
	return TRUE;
}

function load_host_list($loc)
{
	global $credentials;
	$db = new conn_mySQL($credentials);
	$db->db_new_conn();

	// Listing Groups
	$db->add_table(_TABLE_HOST_GROUPS);

	$ret = $db->compile_query("SELECT");
	if($ret['return']) {
		$db->run_query();
		if($db->rows) {
			for($x=0;$x<$db->rows;$x++) {
				$db->step();
				$id = sprintf("GID_%s", $db->res['GID']);
				add_QVLink($id, $db->res['Name'], sprintf("view_group.php?GID=%s", $db->res['GID']), FALSE, $db->res['Descr'], _GROUP_VIEW, "ROOT/$loc");
			}
		}
	}
	$db->clear_res();

	// Listing Hosts
	$db->add_table(_TABLE_HOSTS);
	
	$ret = $db->compile_query("SELECT");
	if($ret['return']) {
		$db->run_query();
		if($db->rows) {
			for($x=0;$x<$db->rows;$x++) {
				$db->step();
				$id = sprintf("HID_%s", $db->res['HID']);
				$mid = sprintf("GID_%s", $db->res['GID']);
				$name = sprintf("%s <i>(%s)</i>", $db->res['HostName'], $db->res['IPAddr']);
				add_QVItem($id, $name, sprintf("view_host.php?HID=%s", $db->res['HID']), "images/qview/systems/default.gif", $db->res['Descr'], _GROUP_VIEW, "ROOT/$loc/$mid");
			}
		}
	}
	$db->clear_res();
	$db->db_close();

	return true;
}
?>
