<?
/********************************************************************
Copyright (c) 2003 Jason Sessler

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
********************************************************************/

include "inc/common.php";
include _ABS_ROOT . "/lib/mysql.inc.php";
include _ABS_ROOT . "/lib/authentication.inc.php";
include _ABS_ROOT . "/inc/check_auth.php";

include _ABS_ROOT . "/lib/html.inc.php";
include _ABS_ROOT . "/themes/plain_blue.php";
include _ABS_ROOT . "/lib/module.inc.php";
include _ABS_ROOT . "/inc/midas.inc.php";

printf("<HTML>\n");
printf("<HEAD>\n");
printf("<META HTTP-EQUIV='CACHE-CONTROL' CONTENT='NO-CACHE'>\n");
printf("<META HTTP-EQUIV='PRAGMAS' CONTENT='NO-CACHE'>\n");
printf("<META HTTP-EQUIV=REFRESH CONTENT=\"30\">\n");
printf("<TITLE>%s</TITLE>\n", _APPNAME);
printf("</HEAD>\n");
printf("<LINK rel=stylesheet href=%s type=text/css>\n", $color['css']);

// Pre-Body module call
checkForModuleAction(_SUMMARY_PRE_BODY);

printf("<BODY topmargin=10 leftmargin=10 bgcolor='%s'>\n", $color[4]);

// Upper-Body module call
checkForModuleAction(_SUMMARY_BODY_UPPER);

// Right now the Host Monitoring Alerts are Static on the Summary page
$db = new conn_mysql($credentials);
$db->db_new_conn();
$db->add_table(_TABLE_CHECK_CURRENT);
$db->add_select_item(Array(_TABLE_CHECK_CURRENT => Array("TID", "Status", "Response", "LastCheck"),
						   _TABLE_CHECKS        => Array("CID", "Name AS cName"),
						   _TABLE_HOSTS         => Array("HID", "HostName", "IPAddr"),
						   _TABLE_HOST_GROUPS   => Array("GID", "Name AS gName")));

$db->clause  = sprintf("LEFT join %s on (%s.CID=%s.CID) ", _TABLE_CHECKS, _TABLE_CHECK_CURRENT, _TABLE_CHECKS);
$db->clause .= sprintf("LEFT join %s on (%s.HID=%s.HID) ", _TABLE_HOSTS, _TABLE_CHECK_CURRENT, _TABLE_HOSTS);
$db->clause .= sprintf("LEFT join %s on (%s.GID=%s.GID) ", _TABLE_HOST_GROUPS, _TABLE_HOSTS, _TABLE_HOST_GROUPS);
$db->clause .= "where Status='RED' OR Status='BLUE' OR Status='YELLOW'";
$db->add_extra(sprintf("ORDER by %s.Name,%s.HostName", _TABLE_HOST_GROUPS, _TABLE_HOSTS));

$ret = $db->compile_query("SELECT");
if($ret['return']) {
	$db->run_query();
	$hostAlerts = FALSE;
	for($x=0;$x<$db->rows;$x++) {
		$db->step();
		$hostAlerts[$db->res['GID']]['Name'] = $db->res['gName'];
		$hostAlerts[$db->res['GID']]['Hosts'][$db->res['HID']]['HostName'] = $db->res['HostName'];
		$hostAlerts[$db->res['GID']]['Hosts'][$db->res['HID']]['IPAddr'] = $db->res['IPAddr'];
		$hostAlerts[$db->res['GID']]['Hosts'][$db->res['HID']]['Checks'][$db->res['CID']] =
			Array("cName"     => $db->res['cName'],
			      "TID"       => $db->res['TID'],
				  "Status"    => $db->res['Status'],
				  "Response"  => str_replace(Array("\r","\n"), Array("", "<br>\n"), $db->res['Response']),
				  "LastCheck" => $db->res['LastCheck']);
	}
}

if(is_array($hostAlerts)) {
	foreach($hostAlerts as $group => $grpValue) {
		$hostAlertTable = html_tag("TR",
				              html_tag("TD", sprintf("<b>%s</b>\n", $grpValue['Name']), $color[0], "colspan=5 class=blacksmall align=left"),
						  "", "") .
						  html_tag("TR",
						      html_tag("TD", "<nobr><b>HostName (<i>IP Address</i>)</b></nobr>\n", $color[9], "class='blacksmall' align=center") .
							  html_tag("TD", "<nobr><b>Service</b></nobr>\n", $color[9], "class='blacksmall' align=center") .
							  html_tag("TD", "<nobr><b>Status</b></nobr>\n", $color[9], "class='blacksmall' align=center") .
							  html_tag("TD", "<nobr><b>Last Checked</b></nobr>\n", $color[9], "class='blacksmall' align=center") .
							  html_tag("TD", "<nobr><b>Service Response Returned</b></nobr>\n", $color[9], "class='blacksmall' align=center"),
						  "", "");
		$gP = $hostAlerts[$group]['Hosts'];
		if(is_array($gP)) {
			foreach($gP as $host => $hostValue) {
				$newHost = TRUE;
				$hP = $hostValue['Checks'];
				if(is_array($hP)) {
					foreach($hP as $check => $chkValue) {
						if($newHost) {
						    $tag = html_tag("TD",
									   sprintf("<nobr><A HREF='view_host.php?HID=%s'>%s</A> (<i>%s</i>)</nobr>\n", $host, $hostValue['HostName'], $hostValue['IPAddr']),
								   $color[4], sprintf("rowspan=%d class=blacksmall align=left valign=top", sizeof($hP)));
						    $newHost = FALSE;
						} else {
							$tag = "";
						}

					if(!$chkValue['Response'])
					    $chkValue['Response'] = "No Response Recorded";

					$hostAlertTable .= html_tag("TR", $tag .
										   html_tag("TD", sprintf("<nobr>&nbsp;<A HREF='view_host.php?LOC=viewCheck&HID=%s&TID=%s&CID=%s'>%s</A></nobr>\n", $host, $chkValue['TID'], $check, $chkValue['cName']),
										  	   $color[12], "align=left valign=top class=blacksmall align=left") .
										   html_tag("TD", sprintf("%s\n", $checkStatus[$chkValue['Status']]), $color[12], "align=center valign=top class=blacksmall align=left") .
										   html_tag("TD", sprintf("<nobr>%s</nobr>\n", $chkValue['LastCheck']), $color[12], "align=center valign=top class=blacksmall align=left") .
										   html_tag("TD", sprintf("<nobr>%s</nobr>\n", $chkValue['Response']), $color[12], "align=left valign=top class=blacksmall align=left"),
									   "", "");
					}
				}
			}
		}
		$table .= html_tag("TABLE", $hostAlertTable, $color[10], "width=100% cellspacing=1 cellpadding=2") . "<br>";
	}
}

if($table) {
	echo html_tag("TABLE",
			 html_tag("TR",
			     html_tag("TD", "<b>Host Monitoring Alerts</b>\n", $color[9], "class=blacksmall align=center"),
			 "", "") .
			 html_tag("TR",
			 	 html_tag("TD", $table, $color[3], ""),
			 "", ""),
		 $color[10], "width=95%, cellspacing=1 cellpadding=1 align=center");
} else {
	echo html_tag("TABLE",
			 html_tag("TR",
			     html_tag("TD", "<b>Host Monitoring Alerts</b>\n", $color[9], "class=blacksmall align=center"),
			 "", "") .
			 html_tag("TR",
			 	 html_tag("TD", "No Alerts Detected\n", $color[3], "class=blacksmall align=center"),
			 "", ""),
		 $color[10], "width=95%, cellspacing=1 cellpadding=1 align=center");
}
$table = null;
$db->clear_res();

printf("<br>\n");

// Lower-Body module call
checkForModuleAction(_SUMMARY_BODY_LOWER);

printf("</BODY>\n");
printf("</HTML>\n");

$db->clear_res();
$db->db_close();
$db = null;
?>
