<?
/********************************************************************
Copyright (c) 2003 Jason Sessler

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
********************************************************************/

include "inc/common.php";
include _ABS_ROOT . "/lib/mysql.inc.php";
include _ABS_ROOT . "/lib/authentication.inc.php";
include _ABS_ROOT . "/inc/check_auth.php";

include _ABS_ROOT . "/lib/html.inc.php";
include _ABS_ROOT . "/themes/plain_blue.php";
include _ABS_ROOT . "/lib/module.inc.php";
include _ABS_ROOT . "/inc/midas.inc.php";

printf("<HTML>\n");
printf("<HEAD>\n");
printf("<META HTTP-EQUIV='CACHE-CONTROL' CONTENT='NO-CACHE'>\n");
printf("<META HTTP-EQUIV='PRAGMAS' CONTENT='NO-CACHE'>\n");
printf("<META HTTP-EQUIV=REFRESH CONTENT=\"60\">\n");
printf("<TITLE>%s</TITLE>\n", _APPNAME);
printf("</HEAD>\n");
printf("<LINK rel=stylesheet href=%s type=text/css>\n", $color['css']);

// Pre-Body module call
checkForModuleAction(_VIEWGROUP_PRE_BODY);

printf("<BODY topmargin=10 leftmargin=10 bgcolor='%s'>\n", $color[4]);

// Upper-Body module call
checkForModuleAction(_VIEWGROUP_POST_BODY);

$db = new conn_mySQL($credentials);
$db->db_new_conn();

$db->add_table(_TABLE_HOST_CHECKS);
$db->add_select_item(Array(_TABLE_HOST_CHECKS   => Array("HID", "TID", "CID"),
						   _TABLE_HOSTS         => Array("HostName", "IPAddr"),
						   _TABLE_HOST_GROUPS   => Array("GID", "Name as gName"),
						   _TABLE_CHECKS        => Array("Name as cName"),
						   _TABLE_CHECK_CURRENT => Array("Status", "LastCheck")));

$db->clause  = sprintf("LEFT JOIN %s on (%s.HID=%s.HID) ", _TABLE_HOSTS, _TABLE_HOST_CHECKS, _TABLE_HOSTS);
$db->clause .= sprintf("LEFT JOIN %s on (%s.CID=%s.CID) ", _TABLE_CHECKS, _TABLE_HOST_CHECKS, _TABLE_CHECKS);
$db->clause .= sprintf("LEFT JOIN %s on (%s.CID=%s.CID AND %s.TID=%s.TID AND %s.HID=%s.HID) ",
	_TABLE_CHECK_CURRENT, _TABLE_HOST_CHECKS, _TABLE_CHECK_CURRENT, _TABLE_HOST_CHECKS, _TABLE_CHECK_CURRENT, _TABLE_HOST_CHECKS, _TABLE_CHECK_CURRENT);
$db->clause .= sprintf("LEFT JOIN %s on (%s.GID=%s.GID)", _TABLE_HOST_GROUPS, _TABLE_HOSTS, _TABLE_HOST_GROUPS);

$db->add_extra("ORDER by gName, HostName, cName");

$ret = $db->compile_query("SELECT");

if($ret['return']) {
	$db->run_query();
	$matrix = null;
	$info   = null;
	for($x=0;$x<$db->rows;$x++) {
		$db->step();
		if(!isset($GID) || $GID == $db->res['GID'])
			$matrix[$db->res['GID']][$db->res['HID']][$db->res['TID']][$db->res['CID']] = Array("Status" => $db->res['Status'], "LastCheck" => $db->res['LastCheck']);

		if(!$info['Group'][$db->res['GID']])
		    $info['Group'][$db->res['GID']] = $db->res['gName'];
		if(!$info['Host'][$db->res['HID']])
		    $info['Host'][$db->res['HID']] = Array("HostName" => $db->res['HostName'], "IPAddr" => $db->res['IPAddr']);
		if(!$info['Check'][$db->res['CID']])
		    $info['Check'][$db->res['CID']] = $db->res['cName'];
	}
}

$table = null;

if(is_array($matrix)) {
	foreach($matrix as $GID => $GIDValue) {
		$table .= html_tag("TR",
		              html_tag("TD", sprintf("<b>%s</b>\n", $info['Group'][$GID]), $color[9], "class='blacksmall' align=center"),
				  "", "");
		$column = 1;
		$row = 0;
		$subTable = null;
		$inside = null;
		if(is_array($GIDValue)) {
			foreach($GIDValue as $HID => $HIDValue) {
				if(($column % 3) == 0) {
				    $row++;
					$column = 1;
				}
				$serviceChecks = null;
				if(is_array($HIDValue)) {
					foreach($HIDValue as $TID => $TIDValue) {
						if(is_array($TIDValue)) {
							foreach($TIDValue as $CID => $CIDValue) {
								$serviceChecks .= html_tag("TR",
								                      html_tag("TD", sprintf("<nobr>&nbsp;<A HREF='view_host.php?LOC=viewCheck&HID=%s&TID=%s&CID=%s'>%s</A></nobr>\n",
													  	  $HID, $TID, $CID, $info['Check'][$CID]),
													  $color[12], "class=blacksmall align=left") .
								                      html_tag("TD", sprintf("<nobr>&nbsp;%s</nobr>\n", $info['Host'][$TID]['HostName']), $color[12], "class=blacksmall align=left") .
								                      html_tag("TD", sprintf("<nobr>%s</nobr>\n", $checkStatus[$CIDValue['Status']]), $color[12], "class=blacksmall align=center") .
								                      html_tag("TD", sprintf("<nobr>%s</nobr>\n", $CIDValue['LastCheck']), $color[12], "class=blacksmall align=center"),
												  "", "");
							}
						}
					}
					$subTable[$row] .= html_tag("TD",
					                       html_tag("TABLE",
					                           html_tag("TR",
					                               html_tag("TD", "<b>HostName (<i>IP Address</i>)</b>\n", $color[0], "colspan=4 class=blacksmall align=center"),
											   "", "") .
											   html_tag("TR",
					                               html_tag("TD",
												  	   sprintf("<A HREF='view_host.php?HID=%s'>%s</A> (<i>%s</i>)\n", $HID, $info['Host'][$HID]['HostName'], $info['Host'][$HID]['IPAddr']),
												   $color[12], "colspan=4 class=blacksmall align=center"),
											   "", "") .
											   html_tag("TR",
											       html_tag("TD", "<b>Service</b>\n", $color[0], "class=blacksmall align=center") .
											       html_tag("TD", "<b>Tester</b>\n", $color[0], "class=blacksmall align=center") .
											       html_tag("TD", "<b>Status</b>\n", $color[0], "class=blacksmall align=center") .
											       html_tag("TD", "<b>Last Check</b>\n", $color[0], "class=blacksmall align=center"),
											   "", "") .
												$serviceChecks,
										   $color[10], "width=100% cellspacing=1 cellpadding=1"),
									   $color[3], "width=50% valign=top");
					$column++;
				}
			}
		}
		while(($column % 3) != 0) {
			$subTable[$row] .= html_tag("TD", "&nbsp;\n", $color[3], "width=50% valign=top");
			$column++;
		}

		if(is_array($subTable)) {
			foreach($subTable as $groupTable) {
				$inside .= html_tag("TR", $groupTable, "", "");
			}

			$table .= html_tag("TR",
			              html_tag("TD",
						  	  html_tag("TABLE", $inside, $color[3], "width=100% cellspacing=1 cellpadding=3 align=center"),
						  $color[10], ""),
					  "", "") .
					  html_tag("TR",
			              html_tag("TD", "&nbsp;", $color[4], ""),
					  "", "");
		}
	}
} else {
	$table = html_tag("TR",
		         html_tag("TD", "<b>No Groups Defined</b>\n", $color[9], "width=100% cellspacing=1 cellpadding=1 align=center"),
		     "", "");
}
echo html_tag("TABLE", $table, $color[3], "width=95% cellspacing=0 cellpadding=1 align=center");

$db->clear_res();
$db->db_close();
$db = null;

// Lower-Body module call
checkForModuleAction(_VIEWGROUP_BODY_LOWER);

printf("</BODY>\n");
printf("</HTML>\n");

?>
