/******************************************************************************
* Copyright (c) 2003 Tom Cashmore
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to
* deal in the Software without restriction, including without limitation the
* rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
* sell copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.

* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
* IN THE SOFTWARE.
*
*       Applisation : MIDASa
*       Filename : alert_email.h
*		Defines the string literals used when send text/html emails.
*
*       Updated :
*               11/06/2003 - Added function and header comments.
*
******************************************************************************/

/*****************************************************************************
*	char ALERT_EMAIL_HTML[]
* 		Email Message when sending HTML email. 
*
*	$[] Tags :
*		$[HOSTNAME]$		Hostname of affected host.
*		$[CHECKNAME]$		Name of Check generating event.
*		$[STATUS]$		Status of event (RED, GREEN, YELLOW, 
*					BLUE).
*		$[TIMESTAMP]$		Time stamp of event.
*		$[DETAIL]$		Event detail
*
*	Updated :
*******************************************************************************/
char ALERT_EMAIL_HTML[] = 
"Subject: MIDAS Notification : $[HOSTNAME]$:$[CHECKNAME]$ is $[STATUS]$\r\n"
"MIME-Version: 1.0\r\n"
"Content-Type: text/html; charset=us-ascii\r\n"
"Content-Transfer-Encoding: 7bit\r\n"
"\r\n"
"<HTML>\r\n"
"<HEAD>\r\n"
"<TITLE>MIDAS Alert Email $[HOSTNAME]$</TITLE>\r\n"
"\r\n"
"</HEAD>\r\n"
"<STYLE type='text/css'>\r\n"
"<--\r\n"
"		{ font-family: Arial, Helvetica, sans-serif; font-size: 8pt; margin-left:4; margin-top:4}\r\n"
"p		{ font-family: Arial, Helvetica, sans-serif; font-size: 8pt; letter-spacing: 2px}\r\n"
"\r\n"
"\r\n"
"td		{ font-family: Arial, Helvetica, sans-serif; font-size: 8pt}\r\n"
"h1         { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 14pt; text-decoration: underline; color: #000000 }\r\n"
".bodysmall	{ font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 8pt; font-weight: bold ; color: #000000}\r\n"
"-->\r\n"
"</STYLE>\r\n"
"\r\n"
"\r\n"
"<BODY leftmargin='5' topmargin='5' marginheight='0' marginwidth='0' bgcolor='#FFFFFF'>\r\n"
"<TABLE bgcolor='#376589' width='95%' align='center' cellspacing='1' cellpadding='1'>\r\n"
"<TR>\r\n"
"   <TD bgcolor='#FFFFFF' align='right'>\r\n"
"      <H1>MIDAS</H1>\r\n"
"   </TD>\r\n"
"</TR>\r\n"
"<TR>\r\n"
"   <TD bgcolor='#83A0BA' class='blacksmall' align='center'>\r\n"
"      <b>Host Information</b>\r\n"
"   </TD>\r\n"
"</TR>\r\n"
"<TR>\r\n"
"   <TD bgcolor='#E0E0E0' align='center'>\r\n"
"      <TABLE bgcolor='#E0E0E0' width='100%' cellspacing='1' cellpadding='0'>\r\n"
"      <TR>\r\n"
"         <TD bgcolor='#E0E0E0' width='50%' align='center' valign='top'>\r\n"
"            <TABLE bgcolor='#376589' width='80%' cellspacing='1' cellpadding='2'>\r\n"
"            <TR>\r\n"
"               <TD width='30%' bgcolor='#A2BED4' class='blacksmall' align='center'>\r\n"
"                  <nobr>HostName</nobr>\r\n"
"               </TD>\r\n"
"               <TD width='20%' bgcolor='#A2BED4' class='blacksmall' align='center'>\r\n"
"                  <nobr>Service</nobr>\r\n"
"               </TD>\r\n"
"               <TD width='20%' bgcolor='#A2BED4' class='blacksmall' align='center'>\r\n"
"                  <nobr>Status</nobr>\r\n"
"               </TD>\r\n"
"               <TD width='30%' bgcolor='#A2BED4' class='blacksmall' align='center'>\r\n"
"                  <nobr>Last Check</nobr>\r\n"
"               </TD>\r\n"
"            </TR>\r\n"
"            <TR>\r\n"
"               <TD bgcolor='#EDEDED' class='blacksmall' align='left'>\r\n"
"                  <nobr>&nbsp;$[HOSTNAME]$</nobr>\r\n"
"               </TD>\r\n"
"               <TD bgcolor='#EDEDED' class='blacksmall' align='left'>\r\n"
"                  <nobr>&nbsp;$[CHECKNAME]$</nobr>\r\n"
"               </TD>\r\n"
"               <TD bgcolor='$[STATUS]$' class='blacksmall' align='center'>\r\n"
"                  $[STATUS]$\r\n"
"               </TD>\r\n"
"               <TD bgcolor='#EDEDED' class='blacksmall' align='center'>\r\n"
"                  <nobr>&nbsp;$[TIMESTAMP]$</nobr>\r\n"
"               </TD>\r\n"
"            </TR>\r\n"
"            </TABLE>\r\n"
"            <br>\r\n"
"            <TABLE bgcolor='#376589' width='80%' cellspacing='1' cellpadding='1'>\r\n"
"            <TR>\r\n"
"               <TD bgcolor='#A2BED4' class='blacksmall' align='center'>\r\n"
"                  <b>Current Host Check Response</b>\r\n"
"               </TD>\r\n"
"            </TR>\r\n"
"            <TR>\r\n"
"               <TD bgcolor='#EDEDED' width='90%' class='blacksmall' align='left'>\r\n"
"                  <pre>$[DETAIL]$</pre>\r\n"
"               </TD>\r\n"
"            </TR>\r\n"
"            </TABLE>\r\n"
"         </TD>\r\n"
"      </TR>\r\n"
"      </TABLE>\r\n"
"   </TD>\r\n"
"</TR>\r\n"
"<TR>\r\n"
"   <TD bgcolor='#83A0BA' class='blacksmall' align='center'>\r\n"
"      MIDAS (Monitoring, Intrusion Detection and Administration Server)\r\n"
"   </TD>\r\n"
"</TR>\r\n"

"</TABLE>\r\n"
"\r\n"
"</BODY>\r\n"
"</HTML>\r\n"
"\r\n";

/******************************************************************************
*       char ALERT_EMAIL_TEXT[]
*		Email to send for text-only email alerts.
*
*	$[]$ Tags :
*		See char ALERT_EMAIL_HTML[].
*
*       Updated :
******************************************************************************/
char ALERT_EMAIL_TEXT[] =  
"Subject: MIDAS Notification : $[HOSTNAME]$:$[CHECKNAME]$ is $[STATUS]$\r\n"
"\r\n"
"Time    : $[TIMESTAMP]$\r\n"
"Host    : $[HOSTNAME]$\r\n"
"Service : $[CHECKNAME]$\r\n"
"Status  : $[STATUS]$\r\n"
"\r\n"
"Details:\r\n"
"--------------------------------------------------------------------------------------\r\n"
"$[DETAIL]$\r\n"
"\r\n";
