/******************************************************************************
* Copyright (c) 2003 Tom Cashmore
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to
* deal in the Software without restriction, including without limitation the
* rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
* sell copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.

* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
* IN THE SOFTWARE.
*
*       Applisation : MIDASc
*       Filename : check_local.h
*		Function/struct declares for check_local.c
*
*       Updated :
*               11/07/2003 - Added function and header comments.
*
******************************************************************************/
char * Check_Local_Disk(struct XMLLeaf * CheckLeaf);
char * Check_Local_CPU(struct XMLLeaf * CheckLeaf);
char * Check_Local_Proc(struct XMLLeaf * CheckLeaf);
int Check_Local_Proc_Count(char *pslist, int ZombieOnly);
char * Check_Local_Logs(struct XMLLeaf * CheckLeaf);
int Check_Local_Log_UniqueEntry(char * fname, char * MD5);
char * Check_Local_RAM(struct XMLLeaf * CheckLeaf);

struct MD5Record {
	char	fname[255];
	char	md5[35];
	long	size;
	long	ctime;
	long	mtime;
	long	atime;
	int	uid;
	int	gid;
	int	Type;
};

struct MD5DirTreeResult {
	char 	* Result;
	int	Num;
};

char * Check_Local_MD5(struct XMLLeaf * CheckLeaf);
struct MD5DirTreeResult * Check_Local_MD5_DirTree(struct MD5Record * md5record, int RecurFlag);
int Check_Local_MD5_CheckDB(struct MD5Record * md5record);
void Check_Local_MD5_UpdateDB(struct MD5Record * md5record);
char * Check_Local_MD5_Deleted();
struct MD5Record * Check_Local_MD5_FindRecordByFname(struct MD5Record * md5record);
