/******************************************************************************
* Copyright (c) 2003 Tom Cashmore
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to
* deal in the Software without restriction, including without limitation the
* rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
* sell copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.

* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
* IN THE SOFTWARE.
*
*       Applisation : MIDASc
*       Filename : client.c
*		Functions for performing 'Client' things.
*
*       Updated :
*               11/07/2003 - Added function and header comments.
*		12/09/2003 - Fixed winsock support.
*		02/21/2004 - Moved SendToServer() to a Common dir.
*
******************************************************************************/
#include <stdio.h>
#include <stdlib.h>

#include "includes.h"
#include "extern.h"

#include "../Common/Commoninclude.h"

/******************************************************************************
*       struct XMLLeaf * QueryChecks(void)
*		Send a RETURNCHECKS query to MIDASd and returns the resulting
*		XML check options.
*
*       Updated :
******************************************************************************/
struct XMLLeaf * QueryChecks(void)
{
	char * Query = 0;
	char * ServerResponse = 0;
	struct XMLLeaf * ServerXMLResponse = 0;
		
	Query = dsprintf(Query, "<CLIENT><VER>%s</VER><HID>%s</HID><TYPE>RETURNCHECKS</TYPE></CLIENT>", MIDASVER, ReturnXMLLeafValue(ConfigXMLTree, "CONFIG.HID"));
	
	MyDebug(__LINE__, __FILE__, LOG_SOCKET, "[QueryChecks]-[Sending : %s]", Query);
	
	ServerResponse = SendToServer(Query);
	Query = dfree(Query);
		
	if(ServerResponse)
	{
		ServerXMLResponse = StringToXMLTree(ServerResponse);
		
		ServerResponse = dfree(ServerResponse);
		
		return(ServerXMLResponse);
	} else {
		return(NULL);
	}
}
