/******************************************************************************
* Copyright (c) 2003 Tom Cashmore
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to
* deal in the Software without restriction, including without limitation the
* rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
* sell copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.

* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
* IN THE SOFTWARE.
*
*       Applisation : MIDASd
*       Filename : processclient.h
* 		Function defines for processclient.c
*
*       Updated :
*               11/07/2003 - Added function and header comments.
*		11/20/2003 - Added ValidHID() and SnortIsSniffer().
*
******************************************************************************/
char * ProcessClientRequest_InSession(struct XMLLeaf * ClientXMLTree);
char * ProcessClientRequest_OutOfSession(struct XMLLeaf * ClientXMLTree);

char * ReturnClientChecks(char * HID, MYSQL * mysql);

char * UpdateCheckStatus(struct XMLLeaf * ClientXMLTree, char * TID, MYSQL * mysql);
char * UpdateCheckStatus_PrevStatus(char * TID, char * HID, char * CID, MYSQL * mysql);
int UpdateCheckStatus_AlertOnRed(char * CID, MYSQL * mysql);
int UpdateCheckStatus_ReachMaxAlerts(char * TID, char * HID, char * CID, MYSQL * mysql, int RequireMinFail);
int UpdateCheckStatus_DoAlert(char * TID, char * HID, char * CID, MYSQL * mysql);
int UpdateCheckStatus_RedAlertIssued(char * TID, char * HID, char * CID, MYSQL * mysql);

char * ReturnSnortConfig(struct XMLLeaf * ClientXMLTree, char * HID, MYSQL * mysql);
char * UpdateSnortAlert(struct XMLLeaf * ClientXMLTree, char * HID, MYSQL * mysql);
char * ReturnHIDQuery(struct XMLLeaf * ClientLeaf, MYSQL * mysql);

void ProcessClientStats(struct XMLLeaf * ClientLeaf, char * SegmentName, char * HID, MYSQL * mysql);

char * UpdateNetStats(struct XMLLeaf * LocalLeaf, char *, MYSQL * mysql);

char * ReturnNetMon(char * HID, MYSQL * mysql);
int ValidHID(char * HID, MYSQL * mysql);
int SnortIsSniffer(char * HID, MYSQL * mysql);
char * UpdateMACIP(struct XMLLeaf * CheckLeaf, char * HID, MYSQL * mysql);
char * UpdateNetworkSessions(struct XMLLeaf * CheckLeaf, char * HID, MYSQL * mysql);
