/******************************************************************************
* Copyright (c) 2003 Tom Cashmore
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to
* deal in the Software without restriction, including without limitation the
* rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
* sell copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.

* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
* IN THE SOFTWARE.
*
*       Applisation : MIDASn
*       Filename : MIDASn.h
* 		Function defines for MIDASn.c
*
*       Updated :
*               11/10/2003 - Added function and header comments.
*
******************************************************************************/
#include <pcap.h>

struct etherpacket {
	struct ethhdr		eth;	
	struct iphdr		ip;
	struct tcphdr		tcp;
	char			data[8192];
};

struct PortStat {
	char		* Protocol;
	unsigned	SrcPort;
	unsigned	DstPort;
	unsigned	Count;
	unsigned	Bytes;
	struct PortStat * NextStat;
};

struct SessStat {
	char 		* SrcIP;
	char		* DstIP;
	char		* Protocol;
	unsigned	SrcPort;
	unsigned	DstPort;
	unsigned	Count;
	unsigned	Bytes;
	unsigned	StartTime;
	unsigned	EndTime;
	struct SessStat * NextSess;
};

struct MacStat {
	char		* Mac;
	char		* IP;
	struct MacStat * NextMac;
};
 	
struct NetStat {
	unsigned	TotalPkt;
	unsigned	TotalPktCount;
	unsigned	TCPPkt;
	unsigned	TCPPktCount;
	unsigned	UDPPkt;
	unsigned	UDPPktCount;
	unsigned	ICMPPkt;
	unsigned	ICMPPktCount;
	unsigned	OtherPkt;
	unsigned	OtherPktCount;
	struct PortStat * PortStats;
	struct SessStat * SessStats;
	struct MacStat  * MacStats;
};

pcap_t * initdevice(void);
void deinitdevice(pcap_t * pcap);
void Sniffer();
int ParseCommandLine(int argc, char *argv[]);
void ShowConfig();
struct XMLLeaf * QueryNetmon(struct XMLLeaf * PortLeaf);
void CatchSignal(int sig);

